// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

public class Server
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Resolve RootPOA
        //
        org.omg.PortableServer.POA root =
            org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));
        org.omg.PortableServer.POAManager manager = root.the_POAManager();

        //
        // Create implementation object and activate it on the RootPOA
        //
        Hello_impl helloImpl = new Hello_impl(root);
        Hello hello = helloImpl._this(orb);

        //
        // Register the servant with the BootManager to allow the
        // use of corbaloc URLs
        //
        org.omg.CORBA.Object bmObj =
            orb.resolve_initial_references("BootManager");
        com.ooc.OB.BootManager bm = com.ooc.OB.BootManagerHelper.narrow(bmObj);
        byte[] oid = "Hello".getBytes();
        bm.add_binding(oid, hello);

        //
        // Save reference
        //
        try
        {
            String ref = orb.object_to_string(hello);
            String refFile = "Hello.ref";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
            out.println(ref);
            out.flush();
            file.close();
        }
        catch(java.io.IOException ex)
        {
            System.err.println("hello.Server: can't write to `" +
                               ex.getMessage() + "'");
            return 1;
        }

        //
        // Save HTML
        //
        try
        {
            String ref = orb.object_to_string(hello);
            String refFile = "Hello.html";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
            out.println("<EMBED type=\"application/x-java-applet;" +
                        "version=1.3\"");
            out.println("width=500 height=300 code=\"hello/Client.class\" " +
                        "codebase=\"classes\"");
            out.println("archive=\"OB.jar,OBBiDir.jar\"");
            out.println("ior=\"" + ref + "\"");
            out.println("org.omg.CORBA.ORBClass=com.ooc.CORBA.ORB");
            out.println("org.omg.CORBA.ORBSingletonClass=" +
                        "com.ooc.CORBA.ORBSingleton>");
            out.println("<NOEMBED>");
            out.println("Applet not available");
            out.println("</NOEMBED>");
            out.println("</EMBED>");
            out.flush();
            file.close();
        }
        catch(java.io.IOException ex)
        {
            System.err.println("hello.Server: can't write to `" +
                               ex.getMessage() + "'");
            return 1;
        }

        //
        // Run implementation
        //
        manager.activate();
        orb.run();

        return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
