// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI;

public class bidir implements PluginInit
{
    final private static String version_ = "1.0";

    //
    // Compatibility check. The plug-in should verify that it is
    // compatible with the given OCI version, and raise an exception
    // if not.
    //
    public void
    version(org.omg.CORBA.ORB orb, String ver)
    {
        if(!ver.equals(version_))
            throw new org.omg.CORBA.INITIALIZE("bidir: incompatible OCI " +
                                               "version");
    }

    //
    // Initialize the plug-in for an ORB
    //
    public com.ooc.OCI.Plugin
    init(org.omg.CORBA.ORB orb, org.omg.CORBA.StringSeqHolder args)
    {
        com.ooc.CORBA.ORB oborb = (com.ooc.CORBA.ORB)orb;
        java.util.Properties props = oborb.properties();

        //
        // Parse arguments
        //
        args.value = parse_args(args.value, props);

        String peer = props.getProperty("ooc.bidir.peer");
        if(peer == null)
        {
            //
            // Compose a default peer ID from the current time
            //
            peer = "" + System.currentTimeMillis();
        }

        return new com.ooc.OCI.BiDir.Plugin_impl(orb, peer);
    }

    //
    // Parse BiDir arguments. The return value is the a new array
    // with the BiDir arguments removed.
    //
    public static String[]
    parse_args(String[] args, java.util.Properties props)
    {
        //
        // Process the command-line arguments
        //
        int i = 0;
        while(i < args.length)
        {
            if(args[i].equals("-BIDIRpeer"))
            {
                if(i + 1 >= args.length)
                    throw new org.omg.CORBA.INITIALIZE("bidir: argument " +
                                                       "expected for " +
                                                       "-BIDIRpeer");
                props.put("ooc.bidir.peer", args[i + 1]);
                i += 2;
            }
            else if(args[i].startsWith("-BIDIR"))
            {
                throw new org.omg.CORBA.INITIALIZE("bidir: unknown option `" +
                                                   args[i] + "'");
            }
            else
                i++;
        }

        //
        // Filter arguments
        //
        com.ooc.OB.OptionFilter filter;
        filter = new com.ooc.OB.OptionFilter("bidir.parse_args", "-BIDIR");
        filter.add("peer", 1);
        return filter.filter(args);
    }
}
