// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosEventComm.*;
 
class PushConsumer_impl extends PushConsumerPOA
{
    private ORB orb_; // The ORB
    private POA poa_; // My POA
    private boolean slow_; // Is this a slow consumer?

    PushConsumer_impl(ORB orb, POA poa, boolean slow)
    {
	orb_ = orb;
	poa_ = poa;
	slow_ = slow;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    push(Any any)
    {
	//
	// Display event data if Any is a string
	//
	try
	{
	    String s = any.extract_string();
	    System.out.println(s);
	}
	catch(MARSHAL ex)
	{
	}
	if(slow_)
	{
	    try
	    {
		Thread.sleep(2000);
	    }
	    catch(InterruptedException e)
	    {
	    }
	}
    }

    public void
    disconnect_push_consumer()
    {
        byte[] oid = null;
        try
        {
            oid = poa_.servant_to_id(this);
        }
        catch(ServantNotActive ex)
        {
            throw new RuntimeException();
        }
        catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }         

        try
        {
            poa_.deactivate_object(oid);
        }
        catch(ObjectNotActive ex)
        {
            throw new RuntimeException();
        }
        catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }

        orb_.shutdown(false);
    }

    public POA
    _default_POA()
    {
	return poa_;
    }
}
