// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;

public class ShutdownThread extends Thread
{
    private boolean destroy_;
    private long timeout_;
    private ORB orb_;

    //
    // Constructor
    //
    ShutdownThread(ORB orb, long timeout)
    {
	destroy_ = false;
	timeout_ = timeout;
	orb_ = orb;
    }

    synchronized public void
    run()
    {
	try
	{
	    wait(timeout_ * 1000);
	}
	catch(InterruptedException ex)
	{
	}

	if(!destroy_)
	    orb_.shutdown(false);
    }

    synchronized public void
    destroy()
    {
	destroy_ = true;
	notifyAll();
    }
}
