// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosEventComm.*;

class TimerUpdate_impl extends TypedTimerUpdatePOA
{
    private ORB orb_;
    private POA poa_;
    private boolean slow_;

    TimerUpdate_impl(ORB orb, POA poa, boolean slow)
    {
	orb_ = orb;
	poa_ = poa;
	slow_ = slow;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    time_update(String str)
    {
	System.out.println(str);
	if(slow_)
	{
	    try
	    {
		Thread.sleep(2000);
	    }
	    catch(InterruptedException e)
	    {
	    }
	}
    }

    public void
    push(org.omg.CORBA.Any any)
    {
    }

    public void
    disconnect_push_consumer()
    {
        byte[] oid = null;
        try
        {
            oid = poa_.servant_to_id(this);
        }
        catch(ServantNotActive ex)
        {
            throw new RuntimeException();
        }
        catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }

        try
        {
            poa_.deactivate_object(oid);
        }
        catch(ObjectNotActive ex)
        {
            throw new RuntimeException();
        }
        catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }

        orb_.shutdown(false);
    }

}
