// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

class PushConsumer_impl extends org.omg.CosEventComm.PushConsumerPOA
{
    private org.omg.CORBA.ORB orb_;
    private org.omg.PortableServer.POA poa_;

    int totalEvents_;

    int eventCount_;

    boolean verbose_;

    StringBuffer out_;

    PushConsumer_impl(org.omg.CORBA.ORB orb,
		      org.omg.PortableServer.POA poa,
		      int totalEvents,
		      boolean verbose,
		      StringBuffer out)
    {
	orb_ = orb;
	poa_ = poa;
	totalEvents_ = totalEvents;
	eventCount_ = 0;
	verbose_ = verbose;
	out_ = out;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    push(org.omg.CORBA.Any any)
	throws org.omg.CosEventComm.Disconnected
    {
	eventCount_++;

	if(verbose_ && (eventCount_ % 10) == 0)
	{
	    System.err.print("-c-" + eventCount_ + " ");
	    System.err.flush();
	}

	if(eventCount_ == totalEvents_)
	{
	    long now = System.currentTimeMillis();

	    out_.append("Last event received by consumer: ");
	    out_.append(now / 1000);
	    out_.append(".");
	    if(now % 1000 < 100)
		out_.append("0");
	    if(now % 1000 < 10)
		out_.append("0");
	    out_.append(now % 1000);
	    out_.append("\n");

	    if(verbose_)
	    {
		System.err.print("-c-Disconnect ");
		System.err.flush();
	    }

	    disconnect_push_consumer();
	    throw new org.omg.CosEventComm.Disconnected();
	}
    }

    public void
    disconnect_push_consumer()
    {
        byte[] oid = null;
        try
        {
            oid = poa_.servant_to_id(this);
        }
        catch(org.omg.PortableServer.POAPackage.ServantNotActive ex)
        {
            throw new RuntimeException();
        }
	catch(org.omg.PortableServer.POAPackage.WrongPolicy ex)
	{
	}

        try
        {
            poa_.deactivate_object(oid);
        }
        catch(org.omg.PortableServer.POAPackage.ObjectNotActive ex)
        {
            throw new RuntimeException();
        }
	catch(org.omg.PortableServer.POAPackage.WrongPolicy ex)
	{
	}

        orb_.shutdown(false);
    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
	return poa_;
    }
}
