# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= OBEvent.jar

!include $(top_srcdir)\..\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
ALL_JIDLFLAGS	= -I$(top_srcdir)\idl $(JIDLFLAGS)

all:: omg ooc

omg: $(top_srcdir)\lib generated
	$(JIDL) $(ALL_JIDLFLAGS) --package org.omg --output-dir generated \
	$(IDLDIR)\CosEventComm.idl \
	$(IDLDIR)\CosEventChannelAdmin.idl \
	$(IDLDIR)\CosTypedEventComm.idl \
	$(IDLDIR)\CosTypedEventChannelAdmin.idl
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(OB_LIB);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\CosEventComm\*.java \
	generated\org\omg\CosEventChannelAdmin\*.java \
	generated\org\omg\CosTypedEventComm\*.java \
	generated\org\omg\CosTypedEventChannelAdmin\*.java

ooc: $(top_srcdir)\lib generated
	$(JIDL) $(ALL_JIDLFLAGS) --tie --auto-package --output-dir generated \
	$(IDLDIR)\OBEventChannelFactory.idl \
	$(IDLDIR)\OBTypedEventChannelFactory.idl
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(OB_LIB);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\OBEventChannelFactory\*.java \
	com\ooc\OBTypedEventChannelFactory\*.java \
	com\ooc\CosEventChannelAdmin\*.java \
	com\ooc\CosTypedEventChannelAdmin\*.java \
	generated\com\ooc\OBEventChannelFactory\*.java \
	generated\com\ooc\OBTypedEventChannelFactory\*.java \
	com\ooc\CosEvent\*.java

jar:
	cd $(top_srcdir)\lib
	if exist $(NAME) del $(NAME)
	$(JAR) $(JARFLAGS) $(NAME) org com

install:: jar
	copy $(top_srcdir)\lib\$(NAME) $(libdir)

clean::
	-rmdir /s /q $(top_srcdir)\lib
