// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEvent;

import java.util.*;

final public class EventLogger
{
    //
    // The message logger
    //
    com.ooc.OB.Logger logger_;

    //
    // The trace levels
    //
    int traceEvents_ = 0;
    int traceLifecycle_ = 0;

    public EventLogger(com.ooc.OB.Logger logger, Properties properties)
    {
        logger_ = logger;
	
	String propRoot = "ooc.event.trace.";
	Enumeration keys = properties.propertyNames();
	while(keys.hasMoreElements())
	{
	    String key = (String)keys.nextElement();
	    if(!key.startsWith(propRoot))
	        continue;

	    String value = properties.getProperty(key);
	    com.ooc.OB.Assert._OB_assert(value != null);

	    if (key.equals("ooc.event.trace.events"))
	    {
	        try
		{
	            traceEvents_ = Integer.parseInt(value);
		}
		catch(NumberFormatException ex)
		{
		    logger_.warning("Invalid value for ooc.event.trace.events");
		}
	    }
	    else if(key.equals("ooc.event.trace.lifecycle"))
	    {
	        try
		{
	            traceLifecycle_ = Integer.parseInt(value);
		}
		catch(NumberFormatException ex)
		{
		    logger_.warning("Invalid value for" +
		                    " ooc.event.trace.lifecycle");
		}
	    }
	    else
	    {
	        logger_.warning("event: unknown property: " + key);
	    }
	}
    }

    // ----------------------------------------------------------------------
    // EventLogger trace level accessors
    // ----------------------------------------------------------------------

    public int
    traceEvents()
    {
        return traceEvents_;
    }

    public int
    traceLifecycle()
    {
        return traceLifecycle_;
    }

    // ----------------------------------------------------------------------
    // EventLogger logging methods
    // ----------------------------------------------------------------------

    public void
    info(String msg)
    {
        logger_.info(msg);
    }

    public void
    error(String msg)
    {
        logger_.error(msg);
    }

    public void
    warning(String msg)
    {
        logger_.warning(msg);
    }

    public void
    trace(String category, String msg)
    {
        logger_.trace(category, msg);
    }
}
