// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

package com.ooc.CosEvent;

//
// Base class for all proxies
//
public interface ProxyBase
{
    //
    // Disconnect the servant from the ORB
    //
    void deactivateObject();
    
    //
    // Called during disconnect
    //
    void disconnectPeer();

    //
    // Disconnect the proxy
    //
    void disconnect();

    //
    // Don't accept further requests
    //
    void discardRequests();

    //
    // Has this proxy been destroyed?
    //
    boolean destroyed();

    //
    // Can this proxy be reaperd?
    //
    boolean canReap();

    //
    // What was the time of the last request?
    //
    long lastRequestTime();

    //
    // Set the time of the last request
    //
    void stampRequest();

    //
    // Get the name of the proxy
    //
    String getName();
}
