// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;

class AnyPusherThread extends PusherBaseThread
{
    public PushResult pushEvent(Event_impl event)
    {
	com.ooc.OB.Assert._OB_assert(event != null);
	com.ooc.OB.Assert._OB_assert(consumer_ != null);

        PushResult rc;

        try
        {
            consumer_.push(event.any());
            rc = PushResult.Success;
        }
        catch(COMM_FAILURE e)
        {
            rc = PushResult.Retry;
        }
	catch(TRANSIENT e)
	{
	    rc = PushResult.Retry;
	}
	catch(NO_RESPONSE e)
	{
	    rc = PushResult.Retry;
	}
        catch(Exception e)
        {
            rc = PushResult.Failed;
        }
        return rc;
    }

    AnyPusherThread(org.omg.CosEventComm.PushConsumer consumer,
                    org.omg.CosEventChannelAdmin.ProxyPushSupplier proxy,
		    EventLogger logger,
                    long id,
                    long maxEvents,
                    long maxRetries,
                    long retryTimeout,
                    double retryMultiplier)
    {
        super("AnyPusherThread", consumer, proxy, logger, id, maxEvents,
	      maxRetries, retryTimeout, retryMultiplier);
    }
}
