// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTypedEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class ProxyPushSupplier_impl
    extends org.omg.CosEventChannelAdmin.ProxyPushSupplierPOA
    implements ProxyBase
{
    //
    // The ProxyBaseImpl Object
    //
    private ProxyBaseImpl proxyImpl_;

    //
    // My consumer.
    //
    private org.omg.CosEventComm.PushConsumer consumer_;

    // -----------------------------------------------------------------
    // ProxyPushSupplier_impl constructor
    // -----------------------------------------------------------------

    ProxyPushSupplier_impl(ProxyConstructorInfo info)
    {
	info.base = "TypedProxyPushSupplier";
	proxyImpl_ = new ProxyBaseImpl(info, this);
    }

    protected void
    finalize()
        throws Throwable
    {
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------
    
    synchronized public void
    connect_push_consumer(org.omg.CosEventComm.PushConsumer consumer)
	throws org.omg.CosEventChannelAdmin.AlreadyConnected
    {
	if(proxyImpl_.getState() == ProxyState.Destroyed)
	    throw new OBJECT_NOT_EXIST();

	if(proxyImpl_.getState() == ProxyState.Discarding)
	    throw new TRANSIENT();

	if(proxyImpl_.getState() == ProxyState.Connected)
	    throw new org.omg.CosEventChannelAdmin.AlreadyConnected();

	if(consumer == null)
	    throw new BAD_PARAM();

	QoSParameters params = new QoSParameters();
	proxyImpl_.resolveQoSParams(params);

	consumer_ = org.omg.CosEventComm.PushConsumerHelper.narrow(
	    proxyImpl_.applyRequestTimeout(consumer, params)
        );
	
	proxyImpl_.setState(ProxyState.Connected);

	PusherBaseThread pusher =
	    new TypedPusherThread(consumer, this._this(),
	    			  proxyImpl_.getLogger(), proxyImpl_.getId(),
				  params.maxEvents, params.maxRetries,
				  params.retryTimeout, params.retryMultiplier);
	pusher.start();

	com.ooc.OB.Assert._OB_assert(proxyImpl_.getMyPipe() == null);
	proxyImpl_.setMyPipe(new PushPipeSegment(pusher));
	proxyImpl_.getParentPipe().connect(proxyImpl_.getMyPipe());
    }

    synchronized public void
    disconnect_push_supplier()
    {
	if(proxyImpl_.getState() == ProxyState.Destroyed)
	    throw new OBJECT_NOT_EXIST();

	if(proxyImpl_.getState() == ProxyState.Discarding)
	    throw new TRANSIENT();

	proxyImpl_.disconnect();
    }

    public POA
    _default_POA()
    {
        return proxyImpl_.getPoa();
    }

    // ------------------------------------------------------------------
    // ProxyBase implementation
    // ------------------------------------------------------------------

    //
    // Disconnect the servant from the ORB
    //
    public void deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }
    
    //
    // Called during disconnect
    //
    public void disconnectPeer()
    {
	//
	// If we're connected then tell the consumer.
	//
	if(consumer_ != null)
	{
	    try
	    {
		consumer_.disconnect_push_consumer();
	    }                                              
	    catch(SystemException e)
	    {
	    }
	    consumer_ = null;
	}
    }

    //
    // Disconnect the proxy
    //
    public synchronized void disconnect()
    {
	proxyImpl_.disconnect();
    }

    //
    // Don't accept further requests
    //
    public synchronized void discardRequests()
    {
	proxyImpl_.discardRequests();
    }

    //
    // Has this proxy been destroyed?
    //
    public synchronized boolean destroyed()
    {
	return proxyImpl_.destroyed();
    }

    //
    // Can this proxy be reaperd?
    //
    public boolean canReap()
    {
	return false;
    }

    //
    // What was the time of the last request?
    //
    public long lastRequestTime()
    {
	return proxyImpl_.lastRequestTime();
    }

    //
    // Set the time of the last request
    //
    public void stampRequest()
    {
	proxyImpl_.stampRequest();
    }

    //
    // Get the name of the proxy
    //
    public String getName()
    {
	return proxyImpl_.getName();
    }
}
