// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
package com.ooc.CosTypedEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class TypedConsumerAdmin_impl
    extends org.omg.CosTypedEventChannelAdmin.TypedConsumerAdminPOA
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    //
    // My channel type.
    //
    private ChannelType type_;

    // ------------------------------------------------------------------
    // TypedConsumerAdmin_impl constructor
    // ------------------------------------------------------------------

    TypedConsumerAdmin_impl(ORB orb, POA poa, EventLogger logger,
    			    Reaper reaper, PipeSegment pipe, ChannelType type)
    {
	adminImpl_ = new AdminBaseImpl(orb, poa, logger, reaper, pipe, this);
        type_ = type;

        if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event",
	    				 "creating TypedConsumerAdmin");
    }

    protected void
    finalize()
        throws Throwable
    {
        if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event",
	    				 "destroying TypedConsumerAdmin");
    }
                  
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushSupplier.
    //
    public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_push_supplier()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get ProxyPullSupplier.
    //
    public org.omg.CosEventChannelAdmin.ProxyPullSupplier
    obtain_pull_supplier()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get TypedProxyPullSupplier.
    //
    synchronized
    public org.omg.CosTypedEventChannelAdmin.TypedProxyPullSupplier
    obtain_typed_pull_supplier(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.InterfaceNotSupported
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get TypedProxyPushSupplier.
    //
    synchronized
    public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_typed_push_supplier(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.NoSuchImplementation
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();
	
	//
	// Attempt to assign this type id to the channel.
	//
	if(!type_.assignTypeId(typeId))
	    throw new org.omg.CosTypedEventChannelAdmin.
		NoSuchImplementation();
	
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushSupplier_impl p = new ProxyPushSupplier_impl(info);
        adminImpl_.addProxy(p);
	
	return p._this(adminImpl_.getOrb());
    }

    public POA
    _default_POA()
    {
        return adminImpl_.getPoa();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------
    
    public void
    deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }

    public synchronized void
    disconnect()
    {
	adminImpl_.disconnect();
    }

    public synchronized void
    discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
