// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.CosTypedEventChannelAdmin.*;
import org.omg.CosEventChannelAdmin.*;
import java.io.*;
import java.util.*;

public class Admin
{
    private static int tracelevel_ = 0;
    private static int id = 1;

    private static int 
    GetNextID()
    {
	return id++;
    }

    private static void
    Usage() 
    {
        System.err.println("Usage: admin\n\n" +
                       "\tShutdown\n" +
                       "\tCreateChannel\n" +
                       "\tCreateConsumerAdmin <channel-ior>\n" +
                       "\tCreateSupplierAdmin <channel-ior>\n" +
                       "\tCreatePushConsumer <admin-ior>\n" +
                       "\tCreatePushSupplier <admin-ior>\n" +
                       "\tCreatePullConsumer <admin-ior>\n" +
                       "\tCreatePullSupplier <admin-ior>\n" +
                       "\tDestroyChannel <channel-ior>\n" +
                       "\tDestroyProxyConsumer <proxy-ior>\n" +
                       "\tDestroyProxySupplier <proxy-ior>\n" +
                       "\tTypedShutdown\n" +
                       "\tCreateTypedChannel\n" +
                       "\tCreateTypedConsumerAdmin <channel-ior>\n" +
                       "\tCreateTypedSupplierAdmin <channel-ior>\n" +
                       "\tCreateTypedPushConsumer <admin-ior>\n" +
                       "\tCreateTypedPushSupplier <admin-ior>\n" +
                       "\tCreateTypedPullConsumer <admin-ior>\n" +
                       "\tCreateTypedPullSupplier <admin-ior>\n" +
                       "\tDestroyTypedChannel <channel-ior>\n" +
                       "\tDestroyTypedProxyConsumer <proxy-ior>\n" +
                       "\tDestroyTypedProxySupplier <proxy-ior>\n");
    }

    private static com.ooc.OBTypedEventChannelFactory.TypedEventChannelFactory
    GetTypedFactory(ORB orb)
    {
	org.omg.CORBA.Object obj;
	try
	{
	    obj = orb.resolve_initial_references("TypedEventChannelFactory");
	    if(obj == null)
	    {
		TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
				   "`TypedEventChannelFactory' Reference not " +
				   "found");
		System.err.println("ERROR: No `TypedEventChannelFactory' " +
				   "initial reference.");
		System.exit(1);
	    }

	    com.ooc.OBTypedEventChannelFactory.TypedEventChannelFactory 
		factory = com.ooc.OBTypedEventChannelFactory.
		TypedEventChannelFactoryHelper.narrow(obj);
	
	    return factory;
	}
	catch(BAD_PARAM ex)
	{
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "`TypedEventChannelFactory' Initial " +
			       "Reference is not a " +
			       "TypedEventChannelFactory");

	    System.out.println("ERROR: `TypedEventChannelFactory' " +
			       "initial references is not a " +
			       "TypedEventChannelFactory");
	    System.exit(1);
	}
	catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	    System.err.println("Have an invalid name: " +
			       "TypedEventChannelFactory");
	    System.exit(1);
	}
	return null;
    }

    private static com.ooc.OBEventChannelFactory.EventChannelFactory
    GetFactory(ORB orb)
    {
	org.omg.CORBA.Object obj;
	try
	{
	    obj = orb.resolve_initial_references("EventChannelFactory");

	    if(obj == null)
	    {
		TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
				   "`EventChannelFactory' Reference not " +
				   "found");
		System.err.println("ERROR: No `EventChannelFactory' " +
				   "initial reference."); 
		System.exit(1);
	    }

	    com.ooc.OBEventChannelFactory.EventChannelFactory factory  = 
		com.ooc.OBEventChannelFactory.
		EventChannelFactoryHelper.narrow(obj);
	
	    return factory;
	}
	catch(BAD_PARAM ex)
	{
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "`EventChannelFactory' Initial Reference " +
			       "is not an EventChannelFactory");
	    System.out.println("ERROR: `EventChannelFactory' initial " + 
			       "references is not an EventChannelFactory");
	    System.exit(1);
	}
	catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	    System.err.println("Have an invalid name: EventChannelFactory");
	    System.exit(1);
	}
	return null;
    }

    private static EventChannel
    GetChannel(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    EventChannel channel = EventChannelHelper.narrow(obj);
	    return channel;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow channel");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    System.exit(1); 
	}
	return null; 
    }

    private static TypedEventChannel
    GetTypedChannel(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    TypedEventChannel channel = TypedEventChannelHelper.narrow(obj);
	    return channel;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow channel");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    System.exit(1); 
	}
	return null; 
    }

    private static ConsumerAdmin
    GetConsumerAdmin(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    ConsumerAdmin consumer = ConsumerAdminHelper.narrow(obj);
            return consumer;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Consumer Admin");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static TypedConsumerAdmin
    GetTypedConsumerAdmin(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    TypedConsumerAdmin consumer = TypedConsumerAdminHelper.narrow(obj);
            return consumer;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Consumer Admin");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static SupplierAdmin
    GetSupplierAdmin(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    SupplierAdmin supplier = SupplierAdminHelper.narrow(obj);
	    return supplier;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Supplier Admin");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static TypedSupplierAdmin
    GetTypedSupplierAdmin(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    TypedSupplierAdmin supplier = TypedSupplierAdminHelper.narrow(obj);
	    return supplier;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Typed Supplier Admin");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static ProxyPullSupplier
    GetProxyPullSupplier(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    ProxyPullSupplier ps = ProxyPullSupplierHelper.narrow(obj);
	    return ps;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Typed Pull Supplier");
	    System.exit(1);
	}
	catch(OBJECT_NOT_EXIST ex)
	{
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static ProxyPushSupplier
    GetProxyPushSupplier(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    ProxyPushSupplier ps = ProxyPushSupplierHelper.narrow(obj);
	    return ps;
	}
	catch(BAD_PARAM ex)
	{
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static ProxyPullConsumer
    GetProxyPullConsumer(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    ProxyPullConsumer ps = ProxyPullConsumerHelper.narrow(obj);
	    return ps;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Pull Consumer");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static ProxyPushConsumer
    GetProxyPushConsumer(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    ProxyPushConsumer ps = ProxyPushConsumerHelper.narrow(obj);
	    return ps;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Push Consumer");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static TypedProxyPushConsumer
    GetTypedProxyPushConsumer(String ior, ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj = orb.string_to_object(ior);
	    TypedProxyPushConsumer ps = 
		TypedProxyPushConsumerHelper.narrow(obj);
	    return ps;
	}
	catch(BAD_PARAM ex)
	{
	    System.err.println("Couldn't narrow Typed Push Consumer");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
            ex.printStackTrace();
            System.exit(1);
        }
        return null;
    }

    private static int
    Shutdown(ORB orb)
    {
	com.ooc.OBEventChannelFactory.EventChannelFactory factory = 
	    GetFactory(orb);
	try
	{
	    factory.shutdown();
	}
	catch(org.omg.CORBA.TRANSIENT ex)
	{
	    //
	    // This call will deactivate the server and thus
	    // throw an exception.
	    //
	}
	catch(SystemException ex)
	{
	    System.err.println("System exception in Admin Shutdown routine");
	    ex.printStackTrace();
	}
	return 1;
    }
	
    private static int 
    CreateChannel(ORB orb)
    {
	com.ooc.OBEventChannelFactory.EventChannelFactory factory = 
	    GetFactory(orb);
	try
	{
	    String id = "";
	    id += GetNextID();
	    EventChannel channel = factory.create_channel(id);

	    String ior = orb.object_to_string(channel);
	    System.out.println(ior);
	    
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Created Channel");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);

	    return 0;
	}
	catch(com.ooc.OBEventChannelFactory.ChannelAlreadyExists ex)
	{
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Channel already exists");
	    return 1;
	}
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    return 1;
	}
    }	

    private static int
    DestroyChannel(String ch_ior, ORB orb)
    {
	EventChannel channel = GetChannel(ch_ior, orb);
	channel.destroy();
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Destroyed Channel");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ch_ior);
	return 0;
    }   

    private static int
    CreateConsumerAdmin(String ch_ior, ORB orb)
    {
	EventChannel channel = GetChannel(ch_ior, orb);
	ConsumerAdmin consumer = channel.for_consumers();
	String ior = orb.object_to_string(consumer);
	System.out.println(ior);
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Created Consumer Admin");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);
	return 0;
    }

    private static int
    CreateSupplierAdmin(String ior, ORB orb)
    {
	EventChannel channel = GetChannel(ior, orb);
	SupplierAdmin supplier = channel.for_suppliers();
	String supplier_ior = orb.object_to_string(supplier);
	System.out.println(supplier_ior);
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Created Supplier Admin");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, supplier_ior);
	return 0;
    }

    private static int
    CreateConsumer(String ior, ORB orb, String model) 
    {
	SupplierAdmin supplier = GetSupplierAdmin(ior, orb);

	String consumer_ior;
	if(model.equalsIgnoreCase("CreatePushConsumer")) 
	{
	    ProxyPushConsumer consumer = supplier.obtain_push_consumer();
	    consumer_ior = orb.object_to_string(consumer);
	}
	else
	{
	    ProxyPullConsumer consumer = supplier.obtain_pull_consumer();
	    consumer_ior = orb.object_to_string(consumer);
	}
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Created Proxy Consumer");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, consumer_ior);
	System.out.println(consumer_ior);
	return 0;
    }

    private static int
    CreateSupplier(String ior, ORB orb, String model) 
    {
	ConsumerAdmin consumer = GetConsumerAdmin(ior, orb);

	String supplier_ior;
	if(model.equalsIgnoreCase("CreatePushSupplier")) 
	{
	    ProxyPushSupplier supplier = consumer.obtain_push_supplier();
	    supplier_ior = orb.object_to_string(supplier);
	}
	else
	{
	    ProxyPullSupplier supplier = consumer.obtain_pull_supplier();
	    supplier_ior = orb.object_to_string(supplier);
	}
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Created Proxy Supplier");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, supplier_ior);
	System.out.println(supplier_ior);
	return 0;
    }

    private static int
    DestroyProxySupplier(String ior, ORB orb) 
    {
	//
	// Push Supplier
	//
	ProxyPushSupplier pushSupplier = GetProxyPushSupplier(ior, orb);
	if(pushSupplier != null)
	{
	    pushSupplier.disconnect_push_supplier();
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Destroyed Proxy Push Supplier");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);
	    return 0;
	}
	
	//
	// Pull Supplier
	//
	ProxyPullSupplier pullSupplier = GetProxyPullSupplier(ior, orb);
	if(pullSupplier != null)
	{
	    pullSupplier.disconnect_pull_supplier();
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "Destroyed Proxy Pull Supplier");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);
	    return 0;
	}
        return 0;
    }

    private static int
    DestroyProxyConsumer(String ior, ORB orb) 
    {
       
	//
	// Push Consumer 
	//
	ProxyPushConsumer pushConsumer = GetProxyPushConsumer(ior, orb);
	if(pushConsumer != null)
	{
	    pushConsumer.disconnect_push_consumer();
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Destroyed Proxy Push Consumer");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);
	    return 0;
	}
	
	//
	// PullConsumer 
	//
	ProxyPullConsumer pullConsumer = GetProxyPullConsumer(ior, orb);
	if(pullConsumer != null)
	{
	    pullConsumer.disconnect_pull_consumer();
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Destroyed Proxy Pull Consumer");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior);
	    return 0;
	}
	return 0;
    }

    private static int
    TypedShutdown(ORB orb)
    {
	com.ooc.OBTypedEventChannelFactory.TypedEventChannelFactory factory = 
	    GetTypedFactory(orb); 
	try
	{
	    factory.shutdown();
	}
	catch(org.omg.CORBA.TRANSIENT ex)
	{
	    //
	    // This call will deactivate the server and thus
	    // throw an exception.
	    //
	}
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    System.exit(1);
	}
	return 1;
    }
	
    private static int 
    CreateTypedChannel(ORB orb)
    {
	try
	{
	    org.omg.CORBA.Object obj =
		orb.resolve_initial_references("TypedEventService");
	    if(obj == null)
	    {
		TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "No `TypedEventService' initial reference");
		System.exit(1);
	    }

	    TypedEventChannel e = TypedEventChannelHelper.narrow(obj);

	    String ior = orb.object_to_string(e);
	    System.out.println(ior);
	    
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Created default event channel");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior); 
	    return 0;
	}
	catch(BAD_PARAM ex)
	{
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "`TypedEventService' narrows to nil");
	    System.exit(1);
	}
	catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "Can't resolve `TypedEventService'");
	    System.exit(1);
	}
	catch(SystemException ex)
	{
	    ex.printStackTrace();
	    System.exit(1);
	}
	return 1;
    }	

    private static int
    DestroyTypedChannel(String ch_ior, ORB orb)
    {
	TypedEventChannel channel = GetTypedChannel(ch_ior, orb);
	channel.destroy();
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, "Destroyed Typed Channel");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ch_ior); 
	return 0;
    }   

    private static int
    CreateTypedConsumerAdmin(String ch_ior, ORB orb)
    {
	TypedEventChannel channel = GetTypedChannel(ch_ior, orb);
	TypedConsumerAdmin consumer = channel.for_consumers();
	String ior = orb.object_to_string(consumer);
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "Created Typed Consumer Admin");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior); 
	System.out.println(ior);
	return 0;
    }

    private static int
    CreateTypedSupplierAdmin(String ch_ior, ORB orb)
    {
	TypedEventChannel channel = GetTypedChannel(ch_ior, orb);
	TypedSupplierAdmin supplier = channel.for_suppliers();
	String ior = orb.object_to_string(supplier);
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "Created Typed Supplier Admin");
	TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior); 
	System.out.println(ior);
	return 0;
    }

    private static int
    CreateTypedConsumer(String ior, String ref, ORB orb,
			String type)
    {
	TypedSupplierAdmin supplier = GetTypedSupplierAdmin(ior, orb);
	String consumer_ior;
	try
	{
	    if(type.equalsIgnoreCase("CreateTypedPushConsumer"))
	    {
		TypedProxyPushConsumer consumer = 
		    supplier.obtain_typed_push_consumer(ref);
		consumer_ior = orb.object_to_string(consumer);
	    }
	    else
	    {
		ProxyPullConsumer consumer = 
		    supplier.obtain_typed_pull_consumer(ref);
		consumer_ior = orb.object_to_string(consumer);
	    }
	    System.out.println(consumer_ior);
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Created Typed Proxy Consumer");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, consumer_ior); 
	}
	catch(InterfaceNotSupported ex)
	{
            ex.printStackTrace();
            System.exit(1);
	}
	catch(NoSuchImplementation ex)
	{
            ex.printStackTrace();
            System.exit(1);
	}
	return 0;
    }

    private static int
    CreateTypedSupplier(String ior, String ref, ORB orb)
    {
	TypedConsumerAdmin consumer = GetTypedConsumerAdmin(ior, orb);
	String supplier_ior;
	try
	{
	    ProxyPushSupplier supplier = 
		consumer.obtain_typed_push_supplier(ref);
	    supplier_ior = orb.object_to_string(supplier);
	    
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Created Typed Proxy Supplier");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, supplier_ior); 
	    System.out.println(supplier_ior);
	}
	catch(NoSuchImplementation ex)
	{
            ex.printStackTrace();
            System.exit(1);
	}
	return 0;
    }

    private static int
    DestroyTypedProxyConsumer(String ior, ORB orb) 
    {
	TypedProxyPushConsumer pushConsumer =
	    GetTypedProxyPushConsumer(ior, orb);
	if(pushConsumer == null)
	{
	    pushConsumer.disconnect_push_consumer();
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			       "Destroyed Typed Proxy Consumer");
	    TSU.PrintStatusMsg(tracelevel_, "Admin", 4, ior); 
	}
	return 0;
    }

    static int
    run(ORB orb, String args[])
    {
	if(args.length < 1)
	{
	    Usage();
	    return 1;
	}
	
	//
	// See what the command is and evaluate the proper function.
	//
	TSU.PrintStatusMsg(tracelevel_, "Admin", 1, 
			   "Received instruction: " + args[0]);
 
	String arg = args[0].toLowerCase();
	if(arg.equals("shutdown"))
	{
	    if(args.length != 1)
	    {
		Usage();
		return 1;
	    }
	    Shutdown(orb);
	}
	else if(arg.equals("createchannel"))
	{
	    if(args.length != 1)
	    {
		Usage();
		return 1;
	    }
	    CreateChannel(orb);
	}
	else if(arg.equals("destroychannel"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    DestroyChannel(args[1], orb);
	}
	else if(arg.equals("createconsumeradmin"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateConsumerAdmin(args[1], orb);
	}
	else if(arg.equals("createsupplieradmin"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateSupplierAdmin(args[1], orb);
	}
	else if(arg.equals("createpullconsumer") ||
		arg.equals("createpushconsumer"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateConsumer(args[1], orb, args[0]);
	}
	else if(arg.equals("createpushsupplier") ||
		arg.equals("createpullsupplier"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateSupplier(args[1], orb, args[0]);
	}
	else if(arg.equals("destroyproxysupplier") ||
		arg.equals("destroytypedproxysupplier"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    DestroyProxySupplier(args[1], orb);
	}
	else if(arg.equals("destroyproxyconsumer"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    DestroyProxyConsumer(args[1], orb);
	}
	else if(arg.equals("typedshutdown"))
	{
	    if(args.length != 1)
	    {
		Usage();
		return 1;
	    }
	    TypedShutdown(orb);
	}
	else if(arg.equals("createtypedchannel"))
	{
	    if(args.length != 1)
	    {
		Usage();
		return 1;
	    }
	    CreateTypedChannel(orb);
	}
	else if(arg.equals("destroytypedchannel"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    DestroyTypedChannel(args[1], orb);
	}
	else if(arg.equals("createtypedconsumeradmin"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateTypedConsumerAdmin(args[1], orb);
	}
	else if(arg.equals("createtypedsupplieradmin"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    CreateTypedSupplierAdmin(args[1], orb);
	}
	else if(arg.equals("createtypedpushconsumer") ||
		arg.equals("createtypedpullconsumer"))
	{
	    if(args.length != 3)
	    {
		Usage();
		return 1;
	    }
	    CreateTypedConsumer(args[1], args[2], orb, args[0]);
	}
	else if(arg.equals("createtypedpullsupplier") ||
		arg.equals("createtypedpushsupplier"))
	{
	    if(args.length != 3)
	    {
		Usage();
		return 1;
	    }
	    CreateTypedSupplier(args[1], args[2], orb);
	}
	else if(arg.equals("destroytypedproxyconsumer"))
	{
	    if(args.length != 2)
	    {
		Usage();
		return 1;
	    }
	    DestroyTypedProxyConsumer(args[1], orb);
	}
	else
	{
	    System.err.println("Illegal instruction: " + args[0]);	
	    Usage();
	    return 1;
	}
        return 0;
    }

    public static void
    main(String args[])
    {
        Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

    	int status = 0;
	ORB orb = null;

        try
        {
            //
            // Create ORB.
            //
            org.omg.CORBA.StringSeqHolder argsH =
                new org.omg.CORBA.StringSeqHolder(args);
            orb = com.ooc.CORBA.ORB.init(argsH, props, null);

	    java.util.Properties prop = 
		((com.ooc.OBCORBA.ORB_impl)orb).properties();
	    java.util.Enumeration keys = prop.keys();

	    //
	    // Get the trace level.
	    //
	    while(keys.hasMoreElements())
	    {
		String key = (String)keys.nextElement();
		String value = prop.getProperty(key);

		if(key.startsWith("ooc.testsuite.event.trace"))
		{
		    tracelevel_ = Integer.parseInt(prop.getProperty(key));
		    break;
		}
	    }
	    
	    status = run(orb, argsH.value);
	}	
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}
	
	if(orb != null)
	{
	    try
	    {
	        orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}   
