// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNaming;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;

final class BindingIterator_impl extends BindingIteratorPOA
{
    private POA poa_;
    private Binding[] bl_;
    private int idx_;

    BindingIterator_impl(POA poa, Binding[] bl)
    {
	poa_ = poa;
	bl_ = bl;
    }

    synchronized public boolean
    next_one(BindingHolder b)
    {
	if(idx_ < bl_.length)
	{
	    b.value = bl_[idx_++];
	    return true;
	}

	b.value = new Binding();
	b.value.binding_name = new NameComponent[0];
	b.value.binding_type = org.omg.CosNaming.BindingType.nobject;
	return false;
    }

    synchronized public boolean
    next_n(int how_many, BindingListHolder bl)
    {
	if(how_many == 0)
	    throw new BAD_PARAM();

	int len = bl_.length;
	int num = len - idx_ < how_many ? len - idx_ : how_many;

	bl.value = new Binding[num];
	System.arraycopy(bl_, idx_, bl.value, 0, num);
	idx_ += num;

	return num != 0;
    }

    synchronized public void
    destroy()
    {
        try
        {
            byte[] oid = poa_.servant_to_id(this);
            poa_.deactivate_object(oid);
        }
        catch(org.omg.PortableServer.POAPackage.WrongPolicy ex)
        {
            throw new RuntimeException();
        }
        catch(org.omg.PortableServer.POAPackage.ServantNotActive ex)
        {
            throw new RuntimeException();
        }
        catch(org.omg.PortableServer.POAPackage.ObjectNotActive ex)
        {
            throw new RuntimeException();
        }
    }
}
