// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNaming;

//
// Shutdown hook for clean ORB shutdown in case JVM exists.
//
final class ShutdownHook extends java.lang.Thread
{
    private final org.omg.CORBA.ORB orb_;
    
    public ShutdownHook(org.omg.CORBA.ORB orb)
    {
	orb_ = orb;
    }

    public void register()
    {
	//
	// Register this hook with the runtime
	//
	Runtime.getRuntime().addShutdownHook(this);
    }

    public void unregister()
    {
	//
	// Unregister this hook from the runtime
	//
	Runtime.getRuntime().removeShutdownHook(this);
    }

    public void run()
    {
	// 
	// Trigger ORB shutdown.
	//
	orb_.shutdown(false);
    }
}

