// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.GUI;

import com.ooc.CosNamingConsole.*;
import com.ooc.CosNamingConsole.Util.*;
import com.ooc.Util.GUI.*;

public final class WindowFactory
{
    private static LogWindow errorWindow_;
    private static PingWindow pingWindow_;

    private WindowFactory()
    {
    }

    public static LogWindow
    getErrorWindowInstance()
    {
	if(errorWindow_ == null)
	    errorWindow_ =
		new LogWindow(AppStandards.getString("ErrorWindowTitleKey"),
			      new ConsoleExcept());

	return errorWindow_;
    }

    public static PingWindow
    getPingWindowInstance()
    {
	if(pingWindow_ == null)
	    pingWindow_ =
		new PingWindow(AppStandards.getString("PingWindowTitleKey"));

	return pingWindow_;
    }
}
