// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package account;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Resolve Root POA
        //
        org.omg.PortableServer.POA root =
            org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));

        org.omg.PortableServer.POAManager manager = root.the_POAManager();

        //
        // Activate the POAManager and ask the ORB to start accepting
        // method requests
        //
        manager.activate();

        org.omg.CORBA.Object obj =
            orb.string_to_object("relfile:/Example.ref");
        if(obj == null)
        {
            System.err.println("abstract.Client: " +
                               "cannot read IOR from Example.ref");
            return 1;
        }

        Example example = ExampleHelper.narrow(obj);

        Account_impl impl = new Account_impl();
        Account acct = impl._this(orb);
        example.display(acct);

        Currency currency = new Currency_impl();
        example.display(currency);

        return 0;
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            //
            // Set the concurrency model
            //
            args = com.ooc.CORBA.ORB.ParseArgs(args, props, null);
            props.put("ooc.orb.conc_model", "threaded");
            props.put("ooc.orb.oa.conc_model", "threaded");

            //
            // Create ORB
            //
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
