// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package account;

public class Server
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Install value factory
        //
        ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
            CurrencyHelper.id(), new CurrencyFactory_impl());

        //
        // Resolve Root POA
        //
        org.omg.PortableServer.POA root =
            org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));

        org.omg.PortableServer.POAManager manager = root.the_POAManager();

        //
        // Create implementation object
        //
        Example_impl impl = new Example_impl();
        Example example = impl._this(orb);

        //
        // Save reference
        //
        try
        {
            String ref = orb.object_to_string(example);
            String refFile = "Example.ref";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
            out.println(ref);
            out.flush();
            file.close();
        }
        catch(java.io.IOException ex)
        {
            System.err.println("Can't write to `" + ex.getMessage() + "'");
            return 1;
        }

        //
        // Run implementation
        //
        manager.activate();
        orb.run();

        return 0;
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            //
            // Set the appropriate concurrency model via properties.
            // If the user overrides these with an invalid concurrency
            // model on the command line or in a configuration file
            // then the demo will not function correctly.
            //
            args = com.ooc.CORBA.ORB.ParseArgs(args, props, null);
            props.put("ooc.orb.conc_model", "threaded");
            props.put("ooc.orb.oa.conc_model", "thread_per_request");

            //
            // Create ORB
            //
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
