// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package benchmark;

import benchmark.*;
import benchmark.Benchmark.*;
import benchmark.Benchmark.SequenceTesterPackage.*;

public class CallSequenceTester
{
    private org.omg.CORBA.ORB orb_;

    public
    CallSequenceTester(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
    }

    public void
    ShortSeq_UB_in_t(SequenceTester obj, long iterations)
    {
        short[] s_seq = new short[100];

	for(int i = 0; i < 100; i++)
	    s_seq[i] = (short) i;

	System.out.print(iterations + " ShortSeq_UB in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.ShortSeq_UB_in_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("ShortSeq_UB_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    ShortSeq_UB_out_t(SequenceTester obj, long iterations)
    {
        ShortSeq_UBHolder s_seq = new ShortSeq_UBHolder();

	System.out.print(iterations + " ShortSeq_UB out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.ShortSeq_UB_out_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("ShortSeq_UB_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    ShortSeq_UB_inout_t(SequenceTester obj, long iterations)
    {
        ShortSeq_UBHolder s_seq = new ShortSeq_UBHolder();
        s_seq.value = new short[100];

	for(int i = 0; i < 100; i++)
	    s_seq.value[i] = (short) i;

	System.out.print(iterations + " ShortSeq_UB inout: ");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.ShortSeq_UB_inout_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("ShortSeq_UB_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    ShortSeq_UB_ret_t(SequenceTester obj, long iterations)
    {
        short[] s_seq;

	System.out.print(iterations + " ShortSeq_UB ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        s_seq = obj.ShortSeq_UB_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("ShortSeq_UB_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    FloatSeq_64K_in_t(SequenceTester obj, long iterations)
    {
        float[] f_seq = new float[65536];

	for(int i = 0; i < 65536; i++)
	    f_seq[i] = (float) i;

	System.out.print(iterations + " FloatSeq_64K in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.FloatSeq_64K_in_t(f_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("FloatSeq_64K_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    FloatSeq_64K_out_t(SequenceTester obj, long iterations)
    {
        FloatSeq_64KHolder f_seq = new FloatSeq_64KHolder();

	System.out.print(iterations + " FloatSeq_64K out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.FloatSeq_64K_out_t(f_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("FloatSeq_64K_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    FloatSeq_64K_inout_t(SequenceTester obj, long iterations)
    {
        FloatSeq_64KHolder f_seq = new FloatSeq_64KHolder();
        f_seq.value = new float[65536];

	for(int i = 0; i < 65536; i++)
	    f_seq.value[i] = (float) i;

	System.out.print(iterations + " FloatSeq_64K inout: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.FloatSeq_64K_inout_t(f_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("FloatSeq_64K_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }
    public void
    FloatSeq_64K_ret_t(SequenceTester obj, long iterations)
    {
        float[] f_seq;

	System.out.print(iterations + " FloatSeq_64K ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        f_seq = obj.FloatSeq_64K_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("FloatSeq_64K_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    StringSeq_UB_in_t(SequenceTester obj, long iterations)
    {
        String[] s_seq = new String[100];

	for(int i = 0; i < 100; i++)
	    s_seq[i] = "Marathon Racing #1";

	System.out.print(iterations + " StringSeq_UB in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.StringSeq_UB_in_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("StringSeq_UB_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    StringSeq_UB_out_t(SequenceTester obj, long iterations)
    {
        StringSeq_UBHolder s_seq = new StringSeq_UBHolder();

	System.out.print(iterations + " StringSeq_UB out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.StringSeq_UB_out_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("StringSeq_UB_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    StringSeq_UB_inout_t(SequenceTester obj, long iterations)
    {
        StringSeq_UBHolder s_seq = new StringSeq_UBHolder();
        s_seq.value = new String[100];

	for(int i = 0; i < 100; i++)
	    s_seq.value[i] = "Buy a Chia pet for Xmas!";

	System.out.print(iterations + " StringSeq_UB inout: ");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.StringSeq_UB_inout_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("StringSeq_UB_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }
    public void
    StringSeq_UB_ret_t(SequenceTester obj, long iterations)
    {
        String[] s_seq;

	System.out.print(iterations + " StringSeq_UB ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        s_seq = obj.StringSeq_UB_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("StringSeq_UB_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    OctetSeq_1M_in_t(SequenceTester obj, long iterations)
    {
        byte[] o_seq = new byte[1024*1024];

	for(int i = 0; i < 1024*1024; i++)
	    o_seq[i] = (byte) (i % 256);

	System.out.print(iterations + " OctetSeq_1M in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.OctetSeq_1M_in_t(o_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("OctetSeq_1M_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    OctetSeq_1M_out_t(SequenceTester obj, long iterations)
    {
        OctetSeq_1MHolder o_seq = new OctetSeq_1MHolder();

	System.out.print(iterations + " OctetSeq_1M out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.OctetSeq_1M_out_t(o_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("OctetSeq_1M_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    OctetSeq_1M_inout_t(SequenceTester obj, long iterations)
    {
        OctetSeq_1MHolder o_seq = new OctetSeq_1MHolder();
        o_seq.value = new byte[1024*1024];

	for(int i = 0; i < 1024*1024; i++)
	    o_seq.value[i] = (byte) (i % 256);

	System.out.print(iterations + " OctetSeq_1M inout: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.OctetSeq_1M_inout_t(o_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("OctetSeq_1M_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    OctetSeq_1M_ret_t(SequenceTester obj, long iterations)
    {
        byte[] o_seq;

	System.out.print(iterations + " OctetSeq_1M ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        o_seq = obj.OctetSeq_1M_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("OctetSeq_1M_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    AnySeq_UB_in_t(SequenceTester obj, long iterations)
    {
        org.omg.CORBA.Any[] a_seq = new org.omg.CORBA.Any[100];

	for(int i = 0; i < 100; i++)
	{
	    a_seq[i] = orb_.create_any();
	    a_seq[i].insert_string("What's up, Doc?");
	}

	System.out.print(iterations + " AnySeq_UB in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.AnySeq_UB_in_t(a_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("AnySeq_UB_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    AnySeq_UB_out_t(SequenceTester obj, long iterations)
    {
        AnySeq_UBHolder a_seq = new AnySeq_UBHolder();

	System.out.print(iterations + " AnySeq_UB out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.AnySeq_UB_out_t(a_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("AnySeq_UB_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    AnySeq_UB_inout_t(SequenceTester obj, long iterations)
    {
        AnySeq_UBHolder a_seq = new AnySeq_UBHolder();
        a_seq.value = new org.omg.CORBA.Any[100];

	for(int i = 0; i < 100; i++)
	{
	    a_seq.value[i] = orb_.create_any();
	    a_seq.value[i].insert_short((short) 5);
	}

	System.out.print(iterations + " AnySeq_UB inout: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.AnySeq_UB_inout_t(a_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("AnySeq_UB_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    AnySeq_UB_ret_t(SequenceTester obj, long iterations)
    {
        org.omg.CORBA.Any[] a_seq;

	System.out.print(iterations + " AnySeq_UB ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        a_seq = obj.AnySeq_UB_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("AnySeq_UB_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    U2Seq_UB_in_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.u2[] u2_seq = new benchmark.UserTypes.u2[100];

	for(int i = 0; i < 100; i++)
	{
	    u2_seq[i] = new benchmark.UserTypes.u2();
	    u2_seq[i].d(6.8);
	}

	System.out.print(iterations + " U2Seq_UB in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.U2Seq_UB_in_t(u2_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("U2Seq_UB_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    U2Seq_UB_out_t(SequenceTester obj, long iterations)
    {
        U2Seq_UBHolder u2_seq = new U2Seq_UBHolder();

	System.out.print(iterations + " U2Seq_UB out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.U2Seq_UB_out_t(u2_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("U2Seq_UB_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    U2Seq_UB_inout_t(SequenceTester obj, long iterations)
    {
        U2Seq_UBHolder u2_seq = new U2Seq_UBHolder();
        u2_seq.value = new benchmark.UserTypes.u2[100];

	for(int i = 0; i < 100; i++)
	{
	    u2_seq.value[i] = new benchmark.UserTypes.u2();
	    u2_seq.value[i].d(7.7);
	}

	System.out.print(iterations + " U2Seq_UB inout: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.U2Seq_UB_inout_t(u2_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("U2Seq_UB_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    U2Seq_UB_ret_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.u2[] u2_seq;

	System.out.print(iterations + " U2Seq_UB ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        u2_seq = obj.U2Seq_UB_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("U2Seq_UB_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    S2Seq_UB_in_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.s2[] s_seq = new benchmark.UserTypes.s2[100];

	for(int i = 0; i < 100; i++)
	{
	    s_seq[i] = new benchmark.UserTypes.s2();
	    s_seq[i].s = 234;
	    s_seq[i].l = 723456235;
	    s_seq[i].ll = 2303454020023040L;
	    s_seq[i].us = 4334;
	    s_seq[i].ul = 338;
	    s_seq[i].f = 45434.857F;
	    s_seq[i].d = 1857.37;
	    s_seq[i].c = 'q';
	    s_seq[i].wc = 'b';
	    s_seq[i].st = "Lemond";
	    s_seq[i].ws = "Lemond";
	    s_seq[i].b = false;
	    s_seq[i].o = 7;
	    s_seq[i].a = orb_.create_any();
	    s_seq[i].a.insert_string("Erin go bragh!");
	}

	System.out.print(iterations + " S2Seq_UB in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.S2Seq_UB_in_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("S2Seq_UB_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    S2Seq_UB_out_t(SequenceTester obj, long iterations)
    {
        S2Seq_UBHolder s_seq = new S2Seq_UBHolder();

	System.out.print(iterations + " S2Seq_UB out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.S2Seq_UB_out_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("S2Seq_UB_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    S2Seq_UB_inout_t(SequenceTester obj, long iterations)
    {
        S2Seq_UBHolder s_seq = new S2Seq_UBHolder();
        s_seq.value = new benchmark.UserTypes.s2[100];

	for(int i = 0; i < 100; i++)
	{
	    s_seq.value[i] = new benchmark.UserTypes.s2();
	    s_seq.value[i].s = 234;
	    s_seq.value[i].l = 723456235;
	    s_seq.value[i].ll = 2303454020023040L;
	    s_seq.value[i].us = 4334;
	    s_seq.value[i].ul = 338;
	    s_seq.value[i].f = 45434.857F;
	    s_seq.value[i].d = 1857.37;
	    s_seq.value[i].c = 'q';
	    s_seq.value[i].wc = 'b';
	    s_seq.value[i].st = "Lemond";
	    s_seq.value[i].ws = "Lemond";
	    s_seq.value[i].b = false;
	    s_seq.value[i].o = 7;
	    s_seq.value[i].a = orb_.create_any();
	    s_seq.value[i].a.insert_string("Erin go bragh!");
	}

	System.out.print(iterations + " S2Seq_UB inout: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.S2Seq_UB_inout_t(s_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("S2Seq_UB_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    S2Seq_UB_ret_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.s2[] s_seq;

	System.out.print(iterations + " S2Seq_UB ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        s_seq = obj.S2Seq_UB_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("S2Seq_UB_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    InterfaceSeq_in_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.I[] i_seq = new benchmark.UserTypes.I[100];

	for(int i = 0; i < 100; i++)
	    i_seq[i] = null;

	System.out.print(iterations + " InterfaceSeq in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.InterfaceSeq_in_t(i_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("InterfaceSeq_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    InterfaceSeq_out_t(SequenceTester obj, long iterations)
    {
        InterfaceSeqHolder i_seq = new InterfaceSeqHolder();

	System.out.print(iterations + " InterfaceSeq out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.InterfaceSeq_out_t(i_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("InterfaceSeq_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    InterfaceSeq_inout_t(SequenceTester obj, long iterations)
    {
        InterfaceSeqHolder i_seq = new InterfaceSeqHolder();
        i_seq.value = new benchmark.UserTypes.I[100];

	for(int i = 0; i < 100; i++)
	    i_seq.value[i] = null;

	System.out.print(iterations + " InterfaceSeq inout: ");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.InterfaceSeq_inout_t(i_seq);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("InterfaceSeq_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    InterfaceSeq_ret_t(SequenceTester obj, long iterations)
    {
        benchmark.UserTypes.I[] i_seq;

	System.out.print(iterations + " InterfaceSeq ret: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        i_seq = obj.InterfaceSeq_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("InterfaceSeq_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
	                   (iterations / t.timeElapsed()) + "/sec)");
    }
}
