// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package benchmark;

import benchmark.Benchmark.*;

public class SequenceTester_impl extends SequenceTesterPOA
{
    private org.omg.CORBA.ORB orb_;
    private org.omg.PortableServer.POA poa_;

    private short[] m_shortseq_buf;
    private float[] m_floatseq_buf;
    private String[] m_stringseq_buf;
    private byte[] m_octetseq_buf;
    private org.omg.CORBA.Any[] m_anyseq_buf;
    private benchmark.UserTypes.u2[] m_u2seq_buf;
    private benchmark.UserTypes.s2[] m_s2seq_buf;
    private benchmark.UserTypes.I[] m_Interfaceseq_buf;

    public
     SequenceTester_impl(
	org.omg.CORBA.ORB orb,
    	org.omg.PortableServer.POA poa
    )
    {
        orb_ = orb;
	poa_ = poa;

	//
	// initialize user-defined types
	//
	benchmark.UserTypes.u2 u = new benchmark.UserTypes.u2();
	u.d(234343.772);

	benchmark.UserTypes.s2 s = new benchmark.UserTypes.s2();
	s.s = 234;
	s.l = 723456235;
	s.ll = 2303454020023040L;
	s.us = 4334;
	s.ul = 338;
	s.f = 45434.857F;
	s.d = 1857.37;
	s.c = 'q';
	s.wc = 'b';
	s.st = "Lemond";
	s.ws = "Steve Rex Cycles";
	s.b = false;
	s.o = 7;
	s.a = orb_.create_any();
	s.a.insert_string("No wchars here, buddy...");

	//
	// allocate space for the buffers
	//
	m_shortseq_buf = new short[100];
	m_floatseq_buf = new float[64*1024];
	m_stringseq_buf = new String[100];
	m_octetseq_buf = new byte[1024*1024];
	m_anyseq_buf = new org.omg.CORBA.Any[100];
	m_u2seq_buf = new benchmark.UserTypes.u2[100];
	m_s2seq_buf = new benchmark.UserTypes.s2[100];
	m_Interfaceseq_buf = new benchmark.UserTypes.I[100];

	//
	// initialize bufs of length ub_sequence_length;
	//
	int i;
	for(i = 0; i < 100; ++i)
	{
	    m_shortseq_buf[i] = (short) i;
	    m_stringseq_buf[i] = "Hello, world!";
	    m_anyseq_buf[i] = orb.create_any();
	    m_anyseq_buf[i].insert_long(i);
	    m_u2seq_buf[i] = u;
	    m_s2seq_buf[i] = s;
	    m_Interfaceseq_buf[i] = null;
	}

	//
	// initialize floatseq_buf
	//
	for(i = 0; i < 65536; i++)
	    m_floatseq_buf[i] = (float) i;

	//
	// initialize m_OctetSeq_1M
	//
	for(i = 0; i < 1048576; i++)
	    m_octetseq_buf[i] = (byte) i;
    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
	return poa_;
    }

    //
    // IDL:Benchmark/SequenceTester/ShortSeq_UB_in_t:1.0
    //
    public void
    ShortSeq_UB_in_t(short[] s_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/ShortSeq_UB_out_t:1.0
    //
    public void
    ShortSeq_UB_out_t(
        benchmark.Benchmark.SequenceTesterPackage.ShortSeq_UBHolder s_seq)
    {
        s_seq.value = new short[100];
	System.arraycopy(m_shortseq_buf, 0, s_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/ShortSeq_UB_inout_t:1.0
    //
    public void
    ShortSeq_UB_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.ShortSeq_UBHolder s_seq)
    {
        System.arraycopy(m_shortseq_buf, 0, s_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/ShortSeq_UB_ret_t:1.0
    //
    public short[]
    ShortSeq_UB_ret_t()
    {
        short[] s_seq = new short[100];
	System.arraycopy(m_shortseq_buf, 0, s_seq, 0, 100);
	return s_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/FloatSeq_64K_in_t:1.0
    //
    public void
    FloatSeq_64K_in_t(float[] f_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/FloatSeq_64K_out_t:1.0
    //
    public void
    FloatSeq_64K_out_t(
        benchmark.Benchmark.SequenceTesterPackage.FloatSeq_64KHolder f_seq)
    {
        f_seq.value = new float[65536];
	System.arraycopy(m_floatseq_buf, 0, f_seq.value, 0, 65536);
    }

    //
    // IDL:Benchmark/SequenceTester/FloatSeq_64K_inout_t:1.0
    //
    public void
    FloatSeq_64K_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.FloatSeq_64KHolder f_seq)
    {
	System.arraycopy(m_floatseq_buf, 0, f_seq.value, 0, 65536);
    }

    //
    // IDL:Benchmark/SequenceTester/FloatSeq_64K_ret_t:1.0
    //
    public float[]
    FloatSeq_64K_ret_t()
    {
        float[] f_seq = new float[65536];
	System.arraycopy(m_floatseq_buf, 0, f_seq, 0, 65536);
	return f_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/StringSeq_UB_in_t:1.0
    //
    public void
    StringSeq_UB_in_t(String[] s_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/StringSeq_UB_out_t:1.0
    //
    public void
    StringSeq_UB_out_t(
        benchmark.Benchmark.SequenceTesterPackage.StringSeq_UBHolder s_seq)
    {
        s_seq.value = new String[100];
	System.arraycopy(m_stringseq_buf, 0, s_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/StringSeq_UB_inout_t:1.0
    //
    public void
    StringSeq_UB_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.StringSeq_UBHolder s_seq)
    {
	System.arraycopy(m_stringseq_buf, 0, s_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/StringSeq_UB_ret_t:1.0
    //
    public String[]
    StringSeq_UB_ret_t()
    {
        String[] s_seq = new String[100];
	System.arraycopy(m_stringseq_buf, 0, s_seq, 0, 100);
	return s_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/OctetSeq_1M_in_t:1.0
    //
    public void
    OctetSeq_1M_in_t(byte[] o_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/OctetSeq_1M_out_t:1.0
    //
    public void
    OctetSeq_1M_out_t(
        benchmark.Benchmark.SequenceTesterPackage.OctetSeq_1MHolder o_seq)
    {
        o_seq.value = new byte[1024*1024];
	System.arraycopy(m_octetseq_buf, 0, o_seq.value, 0, 1024*1024);
    }

    //
    // IDL:Benchmark/SequenceTester/OctetSeq_1M_inout_t:1.0
    //
    public void
    OctetSeq_1M_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.OctetSeq_1MHolder o_seq)
    {
	System.arraycopy(m_octetseq_buf, 0, o_seq.value, 0, 1024*1024);
    }

    //
    // IDL:Benchmark/SequenceTester/OctetSeq_1M_ret_t:1.0
    //
    public byte[]
    OctetSeq_1M_ret_t()
    {
        byte[] o_seq = new byte[1024*1024];
	System.arraycopy(m_octetseq_buf, 0, o_seq, 0, 1024*1024);
	return o_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/AnySeq_UB_in_t:1.0
    //
    public void
    AnySeq_UB_in_t(org.omg.CORBA.Any[] a_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/AnySeq_UB_out_t:1.0
    //
    public void
    AnySeq_UB_out_t(
        benchmark.Benchmark.SequenceTesterPackage.AnySeq_UBHolder a_seq)
    {
        a_seq.value = new org.omg.CORBA.Any[100];
	System.arraycopy(m_anyseq_buf, 0, a_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/AnySeq_UB_inout_t:1.0
    //
    public void
    AnySeq_UB_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.AnySeq_UBHolder a_seq)
    {
	System.arraycopy(m_anyseq_buf, 0, a_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/AnySeq_UB_ret_t:1.0
    //
    public org.omg.CORBA.Any[]
    AnySeq_UB_ret_t()
    {
        org.omg.CORBA.Any[] a_seq = new org.omg.CORBA.Any[100];
	System.arraycopy(m_anyseq_buf, 0, a_seq, 0, 100);
	return a_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/U2Seq_UB_in_t:1.0
    //
    public void
    U2Seq_UB_in_t(benchmark.UserTypes.u2[] u2_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/U2Seq_UB_out_t:1.0
    //
    public void
    U2Seq_UB_out_t(
        benchmark.Benchmark.SequenceTesterPackage.U2Seq_UBHolder u2_seq)
    {
        u2_seq.value = new benchmark.UserTypes.u2[100];
	System.arraycopy(m_u2seq_buf, 0, u2_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/U2Seq_UB_inout_t:1.0
    //
    public void
    U2Seq_UB_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.U2Seq_UBHolder u2_seq)
    {
	System.arraycopy(m_u2seq_buf, 0, u2_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/U2Seq_UB_ret_t:1.0
    //
    public benchmark.UserTypes.u2[]
    U2Seq_UB_ret_t()
    {
        benchmark.UserTypes.u2[] u2_seq = new benchmark.UserTypes.u2[100];
	System.arraycopy(m_u2seq_buf, 0, u2_seq, 0, 100);
	return u2_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/S2Seq_UB_in_t:1.0
    //
    public void
    S2Seq_UB_in_t(benchmark.UserTypes.s2[] s2_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/S2Seq_UB_out_t:1.0
    //
    public void
    S2Seq_UB_out_t( 
        benchmark.Benchmark.SequenceTesterPackage.S2Seq_UBHolder s2_seq)
    {
        s2_seq.value = new benchmark.UserTypes.s2[100];
	System.arraycopy(m_s2seq_buf, 0, s2_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/S2Seq_UB_inout_t:1.0
    //
    public void
    S2Seq_UB_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.S2Seq_UBHolder s2_seq)
    {
	System.arraycopy(m_s2seq_buf, 0, s2_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/S2Seq_UB_ret_:1.0
    //
    public benchmark.UserTypes.s2[]
    S2Seq_UB_ret_t()
    {
        benchmark.UserTypes.s2[] s2_seq = new benchmark.UserTypes.s2[100];
	System.arraycopy(m_s2seq_buf, 0, s2_seq, 0, 100);
	return s2_seq;
    }

    //
    // IDL:Benchmark/SequenceTester/InterfaceSeq_in_t:1.0
    //
    public void
    InterfaceSeq_in_t(benchmark.UserTypes.I[] i_seq)
    {
    }

    //
    // IDL:Benchmark/SequenceTester/InterfaceSeq_out_t:1.0
    //
    public void
    InterfaceSeq_out_t(
        benchmark.Benchmark.SequenceTesterPackage.InterfaceSeqHolder i_seq)
    {
        i_seq.value = new benchmark.UserTypes.I[100];
	System.arraycopy(m_Interfaceseq_buf, 0, i_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/InterfaceSeq_inout_t:1.0
    //
    public void
    InterfaceSeq_inout_t(
        benchmark.Benchmark.SequenceTesterPackage.InterfaceSeqHolder i_seq)
    {
	System.arraycopy(m_Interfaceseq_buf, 0, i_seq.value, 0, 100);
    }

    //
    // IDL:Benchmark/SequenceTester/InterfaceSeq_ret_t:1.0
    //
    public benchmark.UserTypes.I[]
    InterfaceSeq_ret_t()
    {
        benchmark.UserTypes.I[] i_seq = new benchmark.UserTypes.I[100];
	System.arraycopy(m_Interfaceseq_buf, 0, i_seq, 0, 100);
	return i_seq;
    }
}
