// ********************************************************************* 
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
// 
// All Rights Reserved
//
// **********************************************************************

package time;

public class Server
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	// Get reference to Root POA
	org.omg.PortableServer.POA poa =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	// Activate POA manager
	org.omg.PortableServer.POAManager mgr = poa.the_POAManager();
        mgr.activate();

	// Create an object
	Time_impl time_servant = new Time_impl();
	Time tm = time_servant._this(orb);

	// Write its stringified reference to stdout
	String ref = orb.object_to_string(tm);
	System.out.println(ref);

	// Accept requests
	orb.run();

        return 0;
    }

    public static void 
    main(String args[])
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
        org.omg.CORBA.ORB orb = null;

	try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
        {
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
        {
	    try
            {
		orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
