// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package custom;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Obtain the server's object reference from a file
        //
        org.omg.CORBA.Object obj = orb.string_to_object("relfile:/Pizza.ref");
        if(obj == null)
        {      
            System.err.println("custom.Client: " +
                               "cannot read IOR from Pizza.ref");
            return 1;
        }

        Pizzeria pizzeria = PizzeriaHelper.narrow(obj);

        //
        // Place an order
        //
        custom.PizzeriaPackage.Topping[] toppings =
            new custom.PizzeriaPackage.Topping[3];
        toppings[0] = custom.PizzeriaPackage.Topping.CHEESE;
        toppings[1] = custom.PizzeriaPackage.Topping.SALAMI;
        toppings[2] = custom.PizzeriaPackage.Topping.PEPPERONI;
        Customer customer = new Customer_impl();
        customer.name = "Bruno Strizzi";
        customer.credit_card = "1234 5678 9012 3456";
        customer.expires = "09/2001";
        pizzeria.order_pizza(custom.PizzeriaPackage.Size.LARGE, toppings,
                             customer);

        return 0;
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
