// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package custom;

public class Server
{
    static int
    run(org.omg.CORBA.ORB orb , String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Create & install value factory - if we forget to do this,
        // the client will receive a MARSHAL exception when attempting
        // to transmit a Employee value.
        //
        ((org.omg.CORBA_2_3.ORB)orb).register_value_factory(
            CustomerHelper.id(), new CustomerFactory_impl());

        //
        // Resolve Root POA
        //
        org.omg.PortableServer.POA root =
            org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));

        org.omg.PortableServer.POAManager manager = root.the_POAManager();

        //
        // Create implementation object
        //
        Pizzeria_impl impl = new Pizzeria_impl(root);
        org.omg.CORBA.Object obj = impl._this(orb);

        //
        // Export the object reference to a file
        //
        try
        {
            String ref = orb.object_to_string(obj);
            String refFile = "Pizza.ref";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
            out.println(ref);
            out.flush();
            file.close();
        }
        catch(java.io.IOException ex)
        {
            System.err.println("custom.Server: can't write to `"
                               + ex.getMessage() + "'");
            return 1;
        }

        //
        // Run implementation
        //
        manager.activate();
        orb.run();

        return 0;
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
