// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package factory;

public class DSIRecord_impl
    extends org.omg.PortableServer.DynamicImplementation
{
    private org.omg.CORBA.ORB orb_;
    private Database database_;

    public
    DSIRecord_impl(org.omg.CORBA.ORB orb, Database database)
    {
        orb_ = orb;
        database_ = database;
    }

    public void
    invoke(org.omg.CORBA.ServerRequest request)
    {
        //
        // Obtain the name of the operation being invoked
        //
        String name = request.operation();

        //
        // Resolve the POACurrent object
        //
        org.omg.CORBA.Object obj = null;
        try
        {
            obj = orb_.resolve_initial_references("POACurrent");
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
        }
        org.omg.PortableServer.Current current =
            org.omg.PortableServer.CurrentHelper.narrow(obj);

        //
        // Get the object ID of the current invocation. The object ID
        // is our database key.
        //
        byte[] oid = null;
        try
        {
            oid = current.get_object_id();
        }
        catch(org.omg.PortableServer.CurrentPackage.NoContext ex)
        {
        }
        String id = new String(oid);
        int key = 0;
        try
        {
            key = Integer.parseInt(id);
        }
        catch(NumberFormatException ex)
        {
            throw new RuntimeException();
        }

        //
        // Ensure the key still refers to a valid record in the database
        //
        Database.DBRecordData data = database_.find(key);
        if(data == null)
            throw new org.omg.CORBA.OBJECT_NOT_EXIST();

        //
        // Service the request
        //

        if(name.equals("_get_key"))
        {
            org.omg.CORBA.NVList list = orb_.create_list(0);
            request.arguments(list);

            org.omg.CORBA.Any any = orb_.create_any();
            any.insert_long(key);
            request.set_result(any);

            return;
        }
        else if(name.equals("_get_data"))
        {
            org.omg.CORBA.NVList list = orb_.create_list(0);
            request.arguments(list);

            org.omg.CORBA.Any any = orb_.create_any();
            any.insert_string(data.data);
            request.set_result(any);

            return;
        }
        else if(name.equals("_set_data"))
        {
            org.omg.CORBA.NVList list = orb_.create_list(0);
            org.omg.CORBA.Any any =
                list.add(org.omg.CORBA.ARG_IN.value).value();
            any.type(orb_.get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
            request.arguments(list);

            data.data = any.extract_string();

            return;
        }
        else
        {
            throw new org.omg.CORBA.BAD_OPERATION();
        }
    }

    public String[]
    _all_interfaces(org.omg.PortableServer.POA poa, byte[] object_id)
    {
        String[] result = new String[1];
        result[0] = DBRecordHelper.id();
        return result;
    }
}
