// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	//
	// We need to set the retry policy on the client
	// object reference to RETRY_ALWAYS
	//
	org.omg.CORBA.Any any = orb.create_any();
	any.insert_short(com.ooc.OB.RETRY_ALWAYS.value);
	org.omg.CORBA.Policy[] pl = new org.omg.CORBA.Policy[1];
        pl[0] = orb.create_policy(com.ooc.OB.RETRY_POLICY_ID.value, any);
	org.omg.CORBA.PolicyManager pm =
	    org.omg.CORBA.PolicyManagerHelper.narrow(
                orb.resolve_initial_references("ORBPolicyManager"));
        pm.add_policy_overrides(pl);

	//
	// Get "hello" object
	//
	org.omg.CORBA.Object obj =
	    orb.string_to_object("relfile:Hello.ref");
	if(obj == null)
	{
	    System.err.println("hello_imr.Client: cannot read IOR from " +
                               "Hello.ref");
	    return 1;
	}

	Hello hello = HelloHelper.narrow(obj);

	//
	// Main loop
	//
	System.out.println(
	    "Enter 'h' for hello, 's' to terminate server, or 'x' for exit:");

	int c;

	try
	{
	    String input;
	    do
	    {
		System.out.print("> ");
		java.io.BufferedReader in = new java.io.BufferedReader(
		    new java.io.InputStreamReader(System.in));
		input = in.readLine();

		if(input.equals("h"))
		    hello.say_hello();
		else if (input.equals("s"))
		{
		    try
		    {
			hello.shutdown();
		    }
		    catch(org.omg.CORBA.TRANSIENT ex)
		    {
	    		System.err.println(ex.getMessage());
		    }
		}
	    }
	    while(!input.equals("x"));
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("hello_imr.Client: can't read from `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	return 0;
    }

    //
    // Standalone program initialization
    //
    public static void
    main(String args[])
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
