// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

import java.awt.*;
import java.awt.event.*;
//import java.applet.*;

final class ServerWindow extends Frame
{
    //
    // The orb
    //
    private org.omg.CORBA.ORB orb_;

    //
    // Hello_impl object
    //
    private Hello_impl hello_;

    //
    // The "Widgets"
    //
    private TextArea outputArea_;
    private MenuItem quit_;
    private MenuItem info_;

    //
    // Constructor
    //
    ServerWindow(org.omg.CORBA.ORB orb, Hello_impl hello)
    {
	orb_ = orb;
	hello_ = hello;

        //
        // Create client window
        //
        MenuBar menubar = new MenuBar();

        Menu menuFile = new Menu("File", true);
        menubar.add(menuFile);
        quit_ = new MenuItem("Quit");
        menuFile.add(quit_);
        quit_.addActionListener(new ActionListener()
        {
            public void
            actionPerformed(ActionEvent e)
            {
		cmdQuit();
            }
        });

        Menu menuHelp = new Menu("Help");
        menubar.add(menuHelp);

        info_ = new MenuItem("About...");
        menuHelp.add(info_);
        info_.addActionListener(new ActionListener()
        {
            public void
            actionPerformed(ActionEvent e)
            {
                cmdAbout();
            }
        });

        menubar.setHelpMenu(menuHelp);

        setMenuBar(menubar);

        setFont(new Font("Courier", Font.PLAIN, 12));

        GridBagLayout l = new GridBagLayout();
        setLayout(l);

        GridBagConstraints c1 = new GridBagConstraints();
        outputArea_ = new TextArea(24, 80);
        outputArea_.setEditable(false);
        c1.fill = GridBagConstraints.BOTH;
        c1.gridx = 0;
        c1.gridy = 0;
        c1.gridwidth = 1;
        c1.gridheight = 1;
        c1.weightx = 1.0;
        c1.weighty = 1.0;
        add(outputArea_);
        l.setConstraints(outputArea_, c1);

        addWindowListener(new WindowAdapter()
        {
            public void
            windowClosing(WindowEvent e)
            {
                cmdQuit();
            }
        });

        pack();
        show();
    }

    //
    // Print message
    //
    public void
    print(String text)
    {
        outputArea_.append(text);
        outputArea_.append("\n");
    }

    //
    // `quit' command
    //
    void
    cmdQuit()
    {
	hello_.shutdown();
    }

    //
    // Print `about' text
    //
    void
    cmdAbout()
    {
	print("****************************************************");
	print("");
	print("ORBacus Hello IMR Demo Application");
	print("");
	print("Copyright (c) 2001");
	print("IONA Technologies, Inc.");
	print("Waltham, MA, USA");
	print("");
	print("All Rights Reserved");
	print("");
	print("****************************************************");
    }
}
