// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package nested;

public class Peer1
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	//
	// Resolve Root POA
	//
	org.omg.PortableServer.POA rootPOA =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	org.omg.PortableServer.POAManager manager = rootPOA.the_POAManager();

	//
	// Create implementation object
	//
	Peer_impl peerImpl = new Peer_impl(rootPOA);
	Peer p1 = peerImpl._this(orb);

	//
	// Save reference
	//
	try
	{
	    String ref = orb.object_to_string(p1);
	    String refFile = "Peer.ref";
	    java.io.FileOutputStream file =
		new java.io.FileOutputStream(refFile);
	    java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println(ref);
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("nested.Peer1: can't write to `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	//
	// Run implementation
	//
	manager.activate();
	orb.run();

	return 0;
    }

    public static void
    main(String args[])
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");
	props.put("ooc.orb.id", "Nested-Peer1");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

        try
        {
	    //
	    // Set the concurrency model to threaded/thread_per_client
	    // if a valid concurrency model wasn't selected
	    //
            args = com.ooc.CORBA.ORB.ParseArgs(args, props, null);
	    String oaModel = props.getProperty("ooc.orb.oa.conc_model");
	    String orbModel = props.getProperty("ooc.orb.conc_model");
	    boolean valid;
	    if(oaModel != null && orbModel != null)
	    {
		valid = orbModel.equals("threaded") &&
		    (oaModel.equals("thread_per_request") ||
		     oaModel.equals("thread_pool"));
	    }
	    else
		valid = false;

	    if(!valid)
	    {
		props.put("ooc.orb.conc_model", "threaded");
		props.put("ooc.orb.oa.conc_model", "thread_per_request");
	    }

	    orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
	    status = 1;
        }

  	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
                ex.printStackTrace();
                status = 1;
	    }
	}

        System.exit(status);
    }
}
