// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package pi;

//
// Servant implementing PIDemo using the Dynamic Skeleton
// Interface
//
final class PIDemoDSI_impl
    extends org.omg.PortableServer.DynamicImplementation
{
    //
    // My ORB
    //
    private org.omg.CORBA.ORB orb_;

    //
    // My POA
    //
    private org.omg.PortableServer.POA poa_;

    //
    // A reference to the object corresponding to the static
    // implementation (used by call_other_impl())
    //
    private PIDemo otherObj_;

    //
    // Supported interfaces
    //
    static final String[] interfaces_ = { "IDL:PIDemo:1.0" };

    // -----------------------------------------------------------------
    // PIDemo_impl constructor
    // -----------------------------------------------------------------

    public PIDemoDSI_impl(org.omg.CORBA.ORB orb,
    			  org.omg.PortableServer.POA poa)
    {
	orb_ = orb;
	poa_ = poa;
    }

    // -----------------------------------------------------------------
    // PIDemo_impl public member implementation
    // -----------------------------------------------------------------

    //
    // Set the reference to the object corresponding to the
    // static implementation
    //
    public void
    setOtherObj(PIDemo obj)
    {
	otherObj_ = obj;
    }

    // -----------------------------------------------------------------
    // Methods for dynamic invocation
    // -----------------------------------------------------------------

    public String[]
    _all_interfaces(org.omg.PortableServer.POA poa, byte[] oid)
    {
	return interfaces_;
    }

    public boolean
    _is_a(String name)
    {
	if(name.equals("IDL:PIDemo:1.0"))
	    return true;
	
	return super._is_a(name);
    }

    public void
    invoke(org.omg.CORBA.ServerRequest request)
    {
	String name = request.operation();

	if(name.equals("noargs"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    return;
	}

	if(name.equals("noargs_oneway"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    return;
	}

	if(name.equals("noargs_return"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    org.omg.CORBA.Any result = orb_.create_any();
	    result.insert_string("PIDemoDSI");
	    request.set_result(result);

	    return;
	}

	if(name.equals("withargs"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    org.omg.CORBA.Any any = orb_.create_any();
	    any.type(orb_.create_string_tc(0));
	    list.add_value("", any, org.omg.CORBA.ARG_IN.value);
	    list.add_value("", any, org.omg.CORBA.ARG_INOUT.value);
	    list.add_value("", any, org.omg.CORBA.ARG_OUT.value);
	    request.arguments(list);

	    for(int i = 1 ; i <= 2 ; i++)
	    {
		try
		{
		    any = list.item(i).value();
		}
		catch(org.omg.CORBA.Bounds ex)
		{
		    throw new RuntimeException();
		}
		any.insert_string("PIDemoDSI");
	    }

	    return;
	}

	if(name.equals("systemexception"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    org.omg.CORBA.Any result = orb_.create_any();
	    org.omg.CORBA.NO_IMPLEMENTHelper.insert(result,
		new org.omg.CORBA.NO_IMPLEMENT());
	    request.set_exception(result);
	    return;
	}

	if(name.equals("userexception"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    org.omg.CORBA.Any result = orb_.create_any();
	    pi.PIDemoPackage.UserHelper.insert(result,
	    				       new pi.PIDemoPackage.User());
	    request.set_exception(result);
	    return;
	}

	if(name.equals("switch_to_static_impl"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    return;
	}

	if(name.equals("switch_to_dynamic_impl"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    return;
	}

	if(name.equals("call_other_impl"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    org.omg.CORBA.Any any = orb_.create_any();
	    any.type(orb_.get_primitive_tc(org.omg.CORBA.TCKind.tk_short));
	    list.add_value("", any, org.omg.CORBA.ARG_IN.value);
	    request.arguments(list);

	    try
	    {
		any = list.item(0).value();
	    }
	    catch(org.omg.CORBA.Bounds ex)
	    {
		throw new RuntimeException();
	    }
	    short level = any.extract_short();

	    if(otherObj_ != null && level > 0)
		otherObj_.call_other_impl(--level);

	    return;
	}

	if(name.equals("deactivate"))
	{
	    org.omg.CORBA.NVList list = orb_.create_list(0);
	    request.arguments(list);

	    orb_.shutdown(false);

	    return;
	}

	org.omg.CORBA.NVList list = orb_.create_list(0);
	request.arguments(list);

	org.omg.CORBA.Any exAny = orb_.create_any();
	org.omg.CORBA.BAD_OPERATIONHelper.insert(exAny,
	    new org.omg.CORBA.BAD_OPERATION());
	request.set_exception(exAny);

    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
        return poa_;
    }
}
