// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package pi;

//
// ServantLocator implementation to demonstrate location forwarding
//
final class PIDemoLocator_impl
    extends org.omg.PortableServer.ServantLocatorPOA
{
    //
    // My ORB
    //
    private org.omg.CORBA.ORB orb_;

    //
    // The PIDemo static implementation
    //
    private org.omg.PortableServer.Servant piDemoImpl_;

    //
    // The PIDemo dynamic implementation
    //
    private org.omg.PortableServer.Servant piDemoDSIImpl_;

    // -----------------------------------------------------------------
    // PIDemoLocator_impl constructor
    // -----------------------------------------------------------------

    PIDemoLocator_impl(org.omg.CORBA.ORB orb,
		       org.omg.PortableServer.Servant piDemoImpl,
    		       org.omg.PortableServer.Servant piDemoDSIImpl)
    {
	orb_ = orb;
	piDemoImpl_ = piDemoImpl;
	piDemoDSIImpl_ = piDemoDSIImpl;
    }

    // -----------------------------------------------------------------
    // Standard IDL to C++ mapping
    // -----------------------------------------------------------------

    public org.omg.PortableServer.Servant
    preinvoke(byte[] oid, org.omg.PortableServer.POA poa,
	      String operation,
	      org.omg.PortableServer.ServantLocatorPackage.
	      CookieHolder the_cookie)
        throws org.omg.PortableServer.ForwardRequest
    {
        String oidString = new String(oid);

        if(oidString.equals("PIDemo"))
	{
	    //
	    // Request for the static implementation
	    //

	    if(operation.equals("switch_to_dynamic_impl"))
	    {
		//
		// switch_to_dynamic_impl() was called -- throw
		// LOCATION_FORWARD with the object associated with
		// dynamic implementation
		//

		byte[] piDemoOid = ("PIDemoDSI").getBytes();

                org.omg.CORBA.Object obj =
                    poa.create_reference_with_id(piDemoOid, "IDL:PIDemo:1.0");

                throw new org.omg.PortableServer.ForwardRequest(obj);
	    }

	    return piDemoImpl_;
	}
	else if(oidString.equals("PIDemoDSI"))
        {
	    //
	    // Request for the dynamic implementation
	    //

            if(operation.equals("switch_to_static_impl"))
            {
		//
		// switch_to_static_impl() was called -- throw
		// LOCATION_FORWARD with the object associated with
		// static implementation
		//

		byte[] piDemoOid = ("PIDemo").getBytes();

                org.omg.CORBA.Object obj =
                    poa.create_reference_with_id(piDemoOid, "IDL:PIDemo:1.0");

                throw new org.omg.PortableServer.ForwardRequest(obj);
            }

            return piDemoDSIImpl_;
        }

        //
        // Unknown object id -- throw OBJECT_NOT_EXIST
        //
        throw new org.omg.CORBA.OBJECT_NOT_EXIST();
    }

    public void
    postinvoke(byte[] oid, org.omg.PortableServer.POA poa,
               String operation, java.lang.Object the_cookie, 
               org.omg.PortableServer.Servant the_servant)
    {
	//
	// Nothing to do here
	//
    }
}
