// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package Simple;

final public class Server
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Resolve Root POA
	//
	org.omg.PortableServer.POA rootPOA =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	//
	// Get a reference to the POA manager
	//
	org.omg.PortableServer.POAManager manager = rootPOA.the_POAManager();

	//
	// Create implementation objects
	//
	SimpleInherit_impl simpleInheritImpl = new SimpleInherit_impl(rootPOA);
	SimpleObject simpleInherit = simpleInheritImpl._this(orb);

        SimpleTie_impl delegate = new SimpleTie_impl();
        SimpleObjectPOATie p = new SimpleObjectPOATie(delegate, rootPOA);
        SimpleObject simpleTie = p._this(orb);

	//
	// Save references
	//
	try
	{
	    String ref = orb.object_to_string(simpleInherit);
	    String refFile = "simple1.ior";
	    java.io.FileOutputStream file =
		new java.io.FileOutputStream(refFile);
	    java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println(ref);
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("simple.Server: can't write to `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	try
	{
	    String ref = orb.object_to_string(simpleTie);
	    String refFile = "simple2.ior";
	    java.io.FileOutputStream file =
		new java.io.FileOutputStream(refFile);
	    java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println(ref);
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("simple.Server: can't write to `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	//
	// Run implementation
	//
	manager.activate();
	orb.run();

	return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");
	props.put("ooc.orb.id", "Simple-Server");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
	    orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
