# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= OB.jar

!include $(top_srcdir)\..\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl


all:: omg ooc

generate: omg-CORBA-generate omg-PortableServer-generate omg-Dynamic-generate \
	  omg-DynamicAny-generate omg-Messaging-generate omg-IIOP-generate \
	  omg-PortableInterceptor-generate ooc-OCI-generate ooc-OB-generate \
	  ooc-PortableServer-generate ooc-PortableInterceptor-generate \
	  ooc-IMR-generate

compile: omg-CORBA-compile omg-PortableServer-compile omg-Dynamic-compile \
	 omg-DynamicAny-compile omg-Messaging-compile omg-IIOP-compile \
	 omg-PortableInterceptor-compile ooc-OCI-compile ooc-OB-compile \
	 ooc-PortableServer-compile \
	 ooc-PortableInterceptor-compile ooc-IMR-compile ooc-impl-compile

omg: omg-CORBA omg-PortableServer omg-Dynamic omg-DynamicAny omg-Messaging \
     omg-IIOP omg-PortableInterceptor

omg-CORBA: omg-CORBA-generate omg-CORBA-compile

omg-CORBA-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --no-skeletons --output-dir generated \
	$(IDLDIR)\OB\Exceptions.idl \
	$(IDLDIR)\OB\Types.idl \
	$(IDLDIR)\OB\Custom.idl \
	$(IDLDIR)\OB\StringValue.idl \
	$(IDLDIR)\OB\IFR1.idl \
	$(IDLDIR)\OB\IFR2.idl \
	$(IDLDIR)\OB\IFR3.idl \
	$(IDLDIR)\OB\IFR4.idl \
	$(IDLDIR)\OB\IFR.idl \
	$(IDLDIR)\OB\ServiceInfo.idl \
	$(IDLDIR)\OB\Bounds.idl \
	$(IDLDIR)\OB\WrongTransaction.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\Current.idl \
	$(IDLDIR)\OB\Policy.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) -I. --no-skeletons \
	--prefix-package omg.org org.omg \
	--auto-package --output-dir generated $(IDLDIR)\OB\CallStack.idl

omg-CORBA-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	org\omg\CORBA\ORBPackage\*.java \
	org\omg\CORBA\TypeCodePackage\*.java \
	org\omg\CORBA\*.java \
	org\omg\CORBA\portable\*.java \
	org\omg\CORBA_2_3\*.java \
	org\omg\CORBA_2_3\portable\*.java \
	org\omg\CORBA_2_4\*.java \
	org\omg\CORBA_2_4\portable\*.java
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\CORBA\*.java \
	generated\org\omg\CORBA\ContainedPackage\*.java \
	generated\org\omg\CORBA\ContainerPackage\*.java \
	generated\org\omg\CORBA\InterfaceDefPackage\*.java \
	generated\org\omg\CORBA\PolicyManagerPackage\*.java \
	generated\org\omg\CORBA\ValueDefPackage\*.java
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)

omg-PortableServer: omg-PortableServer-generate omg-PortableServer-compile

omg-PortableServer-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\POACommon.idl \
	$(IDLDIR)\OB\POAInterface.idl \
	$(IDLDIR)\OB\POAManager.idl \
	$(IDLDIR)\OB\POACurrent.idl \
	$(IDLDIR)\OB\POAPolicies.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\POAAdapterActivator.idl \
	$(IDLDIR)\OB\POAServantManager.idl \
	$(IDLDIR)\OB\POAServantActivator.idl \
	$(IDLDIR)\OB\POAServantLocator.idl

omg-PortableServer-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\PortableServer\*.java \
	generated\org\omg\PortableServer\CurrentPackage\*.java \
	generated\org\omg\PortableServer\POAManagerPackage\*.java \
	generated\org\omg\PortableServer\POAPackage\*.java
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	org\omg\PortableServer\*.java \
	org\omg\PortableServer\ServantLocatorPackage\*.java \
	org\omg\PortableServer\portable\*.java

omg-Dynamic: omg-Dynamic-generate omg-Dynamic-compile

omg-Dynamic-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --no-skeletons --output-dir generated \
	$(IDLDIR)\OB\Dynamic.idl

omg-Dynamic-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\Dynamic\*.java

omg-DynamicAny: omg-DynamicAny-generate omg-DynamicAny-compile

omg-DynamicAny-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\DynamicAny.idl

omg-DynamicAny-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\DynamicAny\*.java \
	generated\org\omg\DynamicAny\DynAnyFactoryPackage\*.java \
	generated\org\omg\DynamicAny\DynAnyPackage\*.java

omg-Messaging: omg-Messaging-generate omg-Messaging-compile

omg-Messaging-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\TimeBase.idl \
	$(IDLDIR)\OB\Messaging.idl

omg-Messaging-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\TimeBase\*.java \
	generated\org\omg\Messaging\*.java

omg-IIOP: omg-IIOP-generate omg-IIOP-compile

omg-IIOP-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --no-skeletons --output-dir generated \
	$(IDLDIR)\OB\IOP.idl \
	$(IDLDIR)\OB\GIOP.idl \
	$(IDLDIR)\OB\IIOP.idl \
	$(IDLDIR)\OB\CONV_FRAME.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\Codec.idl

omg-IIOP-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\IOP\*.java \
	generated\org\omg\IOP\CodecFactoryPackage\*.java \
	generated\org\omg\IOP\CodecPackage\*.java \
	generated\org\omg\GIOP\*.java \
	generated\org\omg\IIOP\*.java \
	generated\org\omg\CONV_FRAME\*.java

omg-PortableInterceptor: omg-PortableInterceptor-generate \
	omg-PortableInterceptor-compile

omg-PortableInterceptor-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\PICommon.idl \
	$(IDLDIR)\OB\PIRequest.idl \
	$(IDLDIR)\OB\PIClient.idl \
	$(IDLDIR)\OB\PIServer.idl \
	$(IDLDIR)\OB\PIPolicy.idl \
	$(IDLDIR)\OB\PIORBInit.idl \
	$(IDLDIR)\OB\PIIOR.idl \
	$(IDLDIR)\OB\PICurrent.idl \
	$(IDLDIR)\OB\PI.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\PIORT.idl

omg-PortableInterceptor-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\PortableInterceptor\*.java \
	generated\org\omg\PortableInterceptor\ORBInitInfoPackage\*.java

ooc: ooc-OCI ooc-OB ooc-PortableServer ooc-PortableInterceptor ooc-IMR ooc-impl

ooc-OCI: ooc-OCI-generate ooc-OCI-compile

ooc-OCI-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\OCI.idl \
	$(IDLDIR)\OB\OCIClient.idl \
	$(IDLDIR)\OB\OCI_IIOP.idl \
	$(IDLDIR)\OB\OCIClient_IIOP.idl
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\OCITypes.idl

ooc-OCI-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\OCI\*.java \
	generated\com\ooc\OCI\IIOP\*.java

ooc-OB: ooc-OB-generate ooc-OB-compile

ooc-OB-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\BootManager.idl \
	$(IDLDIR)\OB\Dispatch.idl \
	$(IDLDIR)\OB\Logger.idl \
	$(IDLDIR)\OB\OBPolicies.idl \
	$(IDLDIR)\OB\UnknownException.idl \
	$(IDLDIR)\OB\URL.idl

ooc-OB-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\OB\*.java \
	generated\com\ooc\OB\BootManagerPackage\*.java \
	generated\com\ooc\OB\URLRegistryPackage\*.java \
	generated\com\ooc\OB\CorbalocProtocolPackage\*.java \
	generated\com\ooc\OB\CorbalocURLSchemePackage\*.java

ooc-PortableServer: ooc-PortableServer-generate ooc-PortableServer-compile

ooc-PortableServer-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\OBPOAInterface.idl \
	$(IDLDIR)\OB\OBPOAManager.idl \
	$(IDLDIR)\OB\OBPOAPolicies.idl

ooc-PortableServer-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\OBPortableServer\*.java \
	generated\com\ooc\OBPortableServer\POAManagerFactoryPackage\*.java

ooc-PortableInterceptor: ooc-PortableInterceptor-generate \
	ooc-PortableInterceptor-compile

ooc-PortableInterceptor-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\OBORBInit.idl \
	$(IDLDIR)\OB\OBPIORT.idl \
	$(IDLDIR)\OB\IMRORT.idl

ooc-PortableInterceptor-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\OBPortableInterceptor\*.java

ooc-IMR: ooc-IMR-generate ooc-IMR-compile

ooc-IMR-generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(IDLDIR) \
	--auto-package --output-dir generated \
	$(IDLDIR)\OB\IMR.idl \
	$(IDLDIR)\OB\IMRState.idl \
	$(IDLDIR)\OB\IMRTypes.idl \
	$(IDLDIR)\OB\OADProcessEndpoint.idl

ooc-IMR-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\IMR\*.java \
	generated\com\ooc\OAD\*.java

ooc-impl: ooc-impl-compile

ooc-impl-compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\OB\*.java \
	com\ooc\IOP\*.java \
	com\ooc\CORBA\*.java \
	com\ooc\OBCORBA\*.java \
	com\ooc\DynamicAny\*.java \
	com\ooc\PortableServer\*.java \
	com\ooc\OBPortableServer\*.java \
	com\ooc\OCI\*.java \
	com\ooc\OCI\IIOP\*.java \
	com\ooc\OAD\*.java \
	com\ooc\PortableInterceptor\*.java \
	com\ooc\OBPortableInterceptor\*.java \
	com\ooc\Messaging\*.java


jar:
	cd $(top_srcdir)\lib
	if exist $(NAME) del $(NAME)
	$(JAR) $(JARFLAGS) $(NAME) org\omg com\ooc

install:: jar
	copy $(top_srcdir)\lib\$(NAME) $(libdir)

clean::
	-rmdir /s /q $(top_srcdir)\lib\org\omg
	-rmdir /s /q $(top_srcdir)\lib\com\ooc
