// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

public final class Net
{
    //
    // Get the "canonical" hostname of the local host. If numeric is
    // true, the canonical IP address will be returned instead.
    //
    public static String
    getCanonicalHostname(boolean numeric)
    {
        String host;

        try
        {
            if(!numeric)
            {
                host = java.net.InetAddress.getLocalHost().getHostName();

                if(host.lastIndexOf('.') == -1)
                {
                    //logger.warning("ORB_init: " +
                    //"hostname is a domainless name\n" +
                    //"using dotted decimal notation " +
                    //"instead of hostname");

                    host =
                        java.net.InetAddress.getLocalHost().getHostAddress();
                }
            }
            else
            {
                host = java.net.InetAddress.getLocalHost().getHostAddress();
            }

            if(host.equals("127.0.0.1") || host.equals("localhost"))
            {
                //logger.warning("ORB_init: " +
                //"hostname lookup returned " +
                //"`localhost' (127.0.0.1)\n" +
                //"Use the -IIOPhost option to select " +
                //"some other hostname");
            }
        }
        catch(java.net.UnknownHostException ex)
        {
            //logger.warning("ORB_init: " +
            //"can't resolve hostname\n" +
            //"using `localhost' (127.0.0.1) " +
            //"instead of hostname");

            if(numeric)
                host = "127.0.0.1";
            else
                host = "localhost";
        }

        return host;
    }
}
