// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OBPortableServer;

//
// This id generation strategy is for user ids, hence it doesn't do
// much
//
class UserIdGenerationStrategy implements IdGenerationStrategy
{
    public byte[]
    createId()
	throws org.omg.PortableServer.POAPackage.WrongPolicy
    {
	throw new org.omg.PortableServer.POAPackage.WrongPolicy();
    }

    public boolean
    isValid(byte[] oid)
    {
	return true;
    }
}

//
// Create the appropriate id generation strategy
//
public class IdGenerationStrategyFactory
{
    public static IdGenerationStrategy
    createIdGenerationStrategy(POAPolicies policies)
    {
	if(policies.idAssignmentPolicy() ==
	   org.omg.PortableServer.IdAssignmentPolicyValue.SYSTEM_ID)
	    return new SystemIdGenerationStrategy(
		policies.lifespanPolicy() ==
		org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
	
	return new UserIdGenerationStrategy();
    }
}
