// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.PortableInterceptor;

abstract class ArgumentStrategy
{
    protected org.omg.CORBA.ORB orb_; // Java only

    //
    // Are arguments available?
    //
    protected boolean argsAvail_;

    //
    // Is the result available?
    //
    protected boolean resultAvail_;

    //
    // Are exceptions available?
    //
    protected boolean exceptAvail_;

    //
    // Are exceptions never available?
    //
    protected boolean exceptNeverAvail_;

    ArgumentStrategy(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
	argsAvail_ = false;
	resultAvail_ = false;
	exceptAvail_ = false;
	exceptNeverAvail_ = false;
    }

    //
    // Get the arguments
    //
    abstract org.omg.Dynamic.Parameter[]
    arguments();

    //
    // Get the exceptions
    //
    abstract org.omg.CORBA.TypeCode[]
    exceptions();

    //
    // Get the result
    //
    abstract org.omg.CORBA.Any
    result();

    //
    // Set the result (server side only)
    //
    abstract void
    setResult(org.omg.CORBA.Any any);

    //
    // Are the args available?
    //
    void
    setArgsAvail(boolean v)
    {
	argsAvail_ = v;
    }

    //
    // Are the exceptions available?
    //
    void
    setExceptAvail(boolean v)
    {
	exceptAvail_ = v;
    }

    //
    // Exceptions are never available
    //
    void
    setExceptNeverAvail()
    {
	exceptNeverAvail_ = true;
    }

    //
    // Is the result available?
    //
    void
    setResultAvail(boolean v)
    {
	resultAvail_ = v;
    }
}
