// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosPropertyService;

import org.omg.CosPropertyService.*;

final class PropertyNamesIterator_impl extends PropertyNamesIteratorPOA
{
    private String[] names_;
    private int idx_;

    PropertyNamesIterator_impl(String[] names)
    {
	names_ = names;
    }

    synchronized public void
    reset()
    {
	idx_ = 0;
    }

    synchronized public boolean
    next_one(org.omg.CORBA.StringHolder property_name)
    {
	if(idx_ < names_.length)
	{
	    property_name.value = names_[idx_++];
	    return true;
	}
	else
	{
	    property_name.value = "";
	    return false;
	}
    }

    synchronized public boolean
    next_n(int how_many, PropertyNamesHolder property_names)
    {
	int len = names_.length;
	int num = len - idx_ < how_many ? len - idx_ : how_many;

	property_names.value = new String[num];

	System.arraycopy(names_, idx_, property_names.value, 0, num);
	idx_ += num;

	return how_many <= num;
    }

    synchronized public void
    destroy()
    {
	org.omg.PortableServer.POA poa = _poa();

	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(org.omg.PortableServer.POAPackage.WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(org.omg.PortableServer.POAPackage.ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(org.omg.PortableServer.POAPackage.ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }
}
