// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosPropertyService;

import org.omg.CosPropertyService.*;

final class PropertySetDefFactory_impl extends PropertySetDefFactoryPOA
{
    private org.omg.PortableServer.POA poa_;
    private org.omg.CORBA.ORB orb_;

    public
    PropertySetDefFactory_impl(org.omg.PortableServer.POA poa,
                               org.omg.CORBA.ORB orb)
    {
	poa_ = poa;
	orb_ = orb;
    }

    public PropertySetDef
    create_propertysetdef()
    {
	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_);
	return propertySetDefImpl._this(orb_);
    }

    public PropertySetDef
    create_constrained_propertysetdef(
	org.omg.CORBA.TypeCode[] allowed_property_types,
	PropertyDef[] allowed_property_defs)
        throws ConstraintNotSupported
    {
	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_, allowed_property_types,
				    allowed_property_defs);
	return propertySetDefImpl._this(orb_);
    }

    public PropertySetDef
    create_initial_propertysetdef(PropertyDef[] initial_property_defs)
	throws MultipleExceptions
    {
	//
	// Sequence with exceptions
	//
	java.util.Vector exceptions = new java.util.Vector();

	int len = initial_property_defs.length;
	for(int i = 0 ; i < len ; i++)
	{
	    if(initial_property_defs[i].property_name.length() == 0)
	    {
		PropertyException ex = new PropertyException(
		    ExceptionReason.invalid_property_name,
		    initial_property_defs[i].property_name);
		exceptions.addElement(ex);
		continue;
	    }
	}

	//
	// Check for exceptions
	//
	if(!exceptions.isEmpty())
	{
	    PropertyException[] ex = new PropertyException[exceptions.size()];
	    exceptions.copyInto(ex);

	    throw new MultipleExceptions(ex);
	}

	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_, initial_property_defs);
	return propertySetDefImpl._this(orb_);
    }
}
