// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosPropertyService;

import org.omg.CosPropertyService.*;

final class PropertySetFactory_impl extends PropertySetFactoryPOA
{
    private org.omg.PortableServer.POA poa_;
    private org.omg.CORBA.ORB orb_;

    public
    PropertySetFactory_impl(org.omg.PortableServer.POA poa,
                            org.omg.CORBA.ORB orb)
    {
	poa_ = poa;
	orb_ = orb;
    }

    public PropertySet
    create_propertyset()
    {
	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_);
	return propertySetDefImpl._this(orb_);
    }

    public PropertySet
    create_constrained_propertyset(
	org.omg.CORBA.TypeCode[] allowed_property_types,
	Property[] allowed_properties)
            throws ConstraintNotSupported
    {
	int len = allowed_properties.length;
	PropertyDef[] p = new PropertyDef[len];

	for(int i = 0 ; i < len ; i++)
	{
	    p[i] = new PropertyDef(allowed_properties[i].property_name,
				   allowed_properties[i].property_value,
				   PropertyModeType.normal);
	}

	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_, allowed_property_types, p);
	return propertySetDefImpl._this(orb_);
    }

    public PropertySet
    create_initial_propertyset(Property[] initial_properties)
	throws MultipleExceptions
    {
	//
	// Sequence with exceptions
	//
	java.util.Vector exceptions = new java.util.Vector();

	int len = initial_properties.length;
	PropertyDef[] p = new PropertyDef[len];

	for(int i = 0 ; i < len ; i++)
	{
	    if(initial_properties[i].property_name.length() == 0)
	    {
		PropertyException ex = new PropertyException(
		    ExceptionReason.invalid_property_name,
		    initial_properties[i].property_name);
		exceptions.addElement(ex);
		continue;
	    }

	    p[i] = new PropertyDef(initial_properties[i].property_name,
				   initial_properties[i].property_value,
				   PropertyModeType.normal);
	}

	//
	// Check for exceptions
	//
	if(!exceptions.isEmpty())
	{
	    PropertyException[] ex = new PropertyException[exceptions.size()];
	    exceptions.copyInto(ex);

	    throw new MultipleExceptions(ex);
	}

	PropertySetDef_impl propertySetDefImpl =
	    new PropertySetDef_impl(poa_, orb_, p);
	return propertySetDefImpl._this(orb_);
    }
}
