// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;
import org.omg.CosPropertyService.*;

//
// Tests for initial PropertySetDef
//
final class TestInitial
{
    static void
    test(ORB orb, PropertySetDefFactory factory)
	throws UserException
    {
	PropertySetDef set;
	Any any = orb.create_any();

        //
        // Set up initial PropertySetDef
        //
        any.insert_string("initial_property_value");
        PropertyDef[] initialProperties = new PropertyDef[1];
        initialProperties[0] = new PropertyDef("initial_property", any,
                                               PropertyModeType.normal);

	set = factory.create_initial_propertysetdef(initialProperties);

	{
	    System.out.print("  Testing get_number_of_properties()... ");

	    com.ooc.OB.Assert._OB_assert(set.get_number_of_properties() == 1);

	    System.out.println("Done!");
	}
	    
	{
	    System.out.print("  Testing is_property_defined()... ");

	    try
	    {
		com.ooc.OB.Assert._OB_assert(
		    set.is_property_defined("initial_property"));
	    }
	    catch(InvalidPropertyName ex)
	    {
		com.ooc.OB.Assert._OB_assert(false);
	    }

	    try
	    {
		com.ooc.OB.Assert._OB_assert(
		    !set.is_property_defined("illegal_property"));
	    }
	    catch(InvalidPropertyName ex)
	    {
		com.ooc.OB.Assert._OB_assert(false);
	    }

	    System.out.println("Done!");
	}

	{
	    System.out.print("  Testing get_property_value()... ");

	    try
	    {
		any = set.get_property_value("initial_property");
	    }
	    catch(InvalidPropertyName ex)
	    {
		com.ooc.OB.Assert._OB_assert(false);
	    }
	    catch(PropertyNotFound ex)
	    {
		com.ooc.OB.Assert._OB_assert(false);
	    }

	    String value = any.extract_string();
	    com.ooc.OB.Assert._OB_assert(value.equals("initial_property_value"));

	    System.out.println("Done!");
	}
    }
}
