// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import java.util.*;
import org.omg.CORBA.*;

class Client
{
    public static void
    main(String[] args)
    {
	Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
	ORB orb = null;
	try
	{
	    //
	    // Create ORB
	    //
	    orb = com.ooc.CORBA.ORB.init(args, props);

	    //
	    // Initialize the time service
	    //
	    com.ooc.CosTime.TimeService.init(orb, args);

	    //
	    // Resolve the TimeService
	    //
	    org.omg.CORBA.Object obj =
		orb.resolve_initial_references("TimeService");
	    org.omg.CosTime.TimeService ts =
		org.omg.CosTime.TimeServiceHelper.narrow(obj);

	    System.out.print("Testing UTO... ");
	    TestUTO.test(ts);
	    System.out.println(" Done!");

	    System.out.print("Testing TIO... ");
	    TestTIO.test(ts);
	    System.out.println(" Done!");

	    System.out.print("Testing TimeHelper... ");
	    TestTimeHelper.test(ts);
	    System.out.println(" Done!");
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}
     
	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
