// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package imageshow;

import java.awt.*;  
import java.awt.event.*;
import javax.swing.*; 
import javax.swing.border.*;

class ImageDisplay extends JLabel implements Scrollable
{
    static final int MAX_INCR = 10;

    //
    // Constructor
    //
    ImageDisplay() 
    {
        setVerticalAlignment(SwingConstants.TOP);
    }

    //
    // Following methods implement Scrollable Interface
    //

    public Dimension 
    getPreferredScrollableViewportSize() 
    {
        return getPreferredSize();
    }

    public int 
    getScrollableUnitIncrement(Rectangle visibleRect, 
                               int orientation, 
                               int direction) 
    {
        int curPos = 0;

        if(orientation == SwingConstants.HORIZONTAL)
        {
            curPos = visibleRect.x;
        }
        else
        {
            curPos = visibleRect.y;
        }

        if(direction < 0) 
        {
            int newPos = curPos - (curPos / MAX_INCR) * MAX_INCR;
            return (newPos == 0) ? MAX_INCR : newPos;
        } 

        return ((curPos / MAX_INCR) + 1) * MAX_INCR - curPos;
    }

    public int 
    getScrollableBlockIncrement(Rectangle visibleRect, 
                                int orientation, 
                                int direction) 
    {
        if(orientation == SwingConstants.HORIZONTAL)
        {
            return visibleRect.width - MAX_INCR;
        }

        return visibleRect.height - MAX_INCR;
    }

    public boolean 
    getScrollableTracksViewportWidth() 
    {
        return false;
    }

    public boolean 
    getScrollableTracksViewportHeight() 
    {
        return false;
    }
}
