// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA  
//                                
// All Rights Reserved         
//                     
// **********************************************************************

package imageshow;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;  
import javax.swing.border.*;

public class InfoDialog extends JDialog 
{
    private JEditorPane info_;

    //
    // Constructor
    //
    InfoDialog(JFrame parentFrame, String title, java.io.File file)
    {
        //
        // Create the info dialog window
        //
        super(parentFrame, title);
        setLocationRelativeTo(parentFrame);

        Border e = BorderFactory.createEtchedBorder(); 

        info_ = createPane(file);
        JScrollPane sp = new JScrollPane(info_);
        sp.setPreferredSize(new Dimension(375, 300));

        JButton okButton = new JButton("Ok");

        //
        // Action to close window
        //
        okButton.addActionListener(new ActionListener()
        {
            public void
            actionPerformed(ActionEvent dummy)
            {
                setVisible(false);
            }
        });

        JPanel p2 = new JPanel();
        p2.add(okButton);

        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());
        contentPane.add(sp, BorderLayout.CENTER);
        contentPane.add(p2, BorderLayout.SOUTH);

        pack();
    }   
    
    //
    // Create and initializes the text area
    //
    private JEditorPane 
    createPane(java.io.File file) 
    {
        String url = null;
        JEditorPane ep = new JEditorPane();
        ep.setEditable(false);

        try 
        {
            url = "file:" + file.getAbsolutePath();
            java.net.URL info = new java.net.URL(url);

            try 
            {
                ep.setPage(info);
            } 
            catch(java.io.IOException e) 
            {
                System.err.println("Read bad URL: " + info);
            }
        } 
        catch(Exception e) 
        {
            System.err.println("Invalid URL formation: " + url);
        }

        return ep;
    }

    //
    // Display dialog window
    //
    public void
    popUp()
    {
        info_.revalidate();
        setVisible(true);
    }
}
