// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IOP;

import org.omg.CORBA.*;

final public class IORAnalyzer
{
    private IORAnalyzer()
    {
    }

    public static org.omg.IOP.IOR
    getIOR(ORB orb, org.omg.CORBA.Object obj)
    {
	if(obj == null)
	    return null;

	String s = orb.object_to_string(obj);
	if(!s.startsWith("IOR:"))
	    return null;

	byte[] buf = com.ooc.OB.HexConverter.asciiToOctets(s, 4);
	if(buf == null)
	    return null;

	com.ooc.CORBA.InputStream in = new com.ooc.CORBA.InputStream(
	    new com.ooc.OCI.Buffer(buf, buf.length), 0, false);
        in._OB_readEndian();
	return org.omg.IOP.IORHelper.read(in);
    }

    public static String
    dumpIOR(ORB orb, org.omg.CORBA.Object obj)
    {
	org.omg.IOP.IOR ior = getIOR(orb, obj);
	if(ior == null)
	    return "Illegal object type\n";

	String result = "  type_id: " + ior.type_id + "\n";

	for(int i = 0 ; i < ior.profiles.length ; i++)
	{
	    ProfileTagAnalyzer a =
		ProfileTagAnalyzer.getAnalyzer(ior.profiles[i]);
	    if(a != null)
		result += a.analyze();
	    else
		result += "  Unknown profile tag\n";
	}

	return result;
    }
}
