// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

//
// This class returns proxy objects with new policy settings
//

package com.ooc.Util.CORBA;

import org.omg.CORBA.*;

final public class Policies
{
    static private ORB orb_;

    public Policies(ORB orb)
    {
	orb_ = orb;
    }

    //
    // Get object with particular timeout constant
    //
    static public org.omg.CORBA.Object
    setTimeout(org.omg.CORBA.Object obj, int timeout)
    {
	Any any = orb_.create_any();
	any.insert_long(timeout);
	Policy[] policies = new Policy[1];

	org.omg.CORBA.Object timeoutObj = null;
	try
	{
	    policies[0] =
		((com.ooc.CORBA.ORB)orb_).
		    create_policy(com.ooc.OB.TIMEOUT_POLICY_ID.value, any);

	    //
	    // NOTE:  This can be changed to obj._set_policy...
	    //        when 2.3/Messaging is adopted.
	    //
	    com.ooc.CORBA.Delegate d = (com.ooc.CORBA.Delegate)
		((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate();
	    timeoutObj = d.set_policy_override(obj, policies,
						SetOverrideType.ADD_OVERRIDE);
	}
	catch(PolicyError ex)
	{
	    //
	    // Do nothing if anything fails
	    //
	    return obj;
	}
	catch(BAD_OPERATION ex)
	{
	    //
	    // Ignore exception thrown when object is local
	    //
	    return obj;
	}

	return timeoutObj;
    }
}
