// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.GUI;

import java.awt.*;
import javax.swing.*;
import com.ooc.Util.*;

/**
 * GUI component used to display messages to a user.
 *
 * This class was extracted from com.ooc.CosNamingConsole.GUI.
 */
final public class MessageArea extends JScrollPane implements MessageLogger
{
    //
    // The parent
    //
    private JFrame parent_;

    //
    // The actual text area
    //
    private JTextArea textArea_;

    //
    // Exception pretty printer
    //
    private Except except_;

    public MessageArea(JFrame parent, Except except)
    {
	parent_ = parent;
	except_ = except;

	textArea_ = new JTextArea("", 20, 80);
	textArea_.setEditable(false);
	textArea_.setLineWrap(true);
        textArea_.setFont(new Font("Courier", Font.PLAIN, 12));

	getViewport().add(textArea_);
	setViewportBorder(BorderFactory.createLineBorder(getForeground()));
    }

    //
    // Add text to message area
    //
    public void
    print(String text)
    {
	parent_.setVisible(true);
//	parent_.setState(Frame.NORMAL);
	textArea_.append(text);
    }

    //
    // Add text with trailing newline
    //
    public void
    println(String text)
    {
	print(text + "\n");
    }

    //
    // Print exception information
    //
    public void
    printException(Exception ex, java.lang.Object obj)
    {
	String except = except_.getException(ex);
	if(except.length() != 0)
	{
	    if(obj != null)
		println(except + ": `" + obj.toString() + "'");
	    else
		println(except);
	}
	else
	    ex.printStackTrace();
    }

    public void
    printException(Exception ex)
    {
	printException(ex, null);
    }

    public void
    clear()
    {
	textArea_.setText("");
    }
}
