// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.LoadBalancing.Util;

import com.ooc.LoadBalancing.*;

//
// IDL:ooc.com/LoadBalancing/LoadCalculator:1.0
//
public class LoadCalculator_impl
    extends org.omg.CORBA.LocalObject
    implements LoadCalculator
{
    //
    // The number of active requests
    //
    private int activeRequests_;

    //
    // The number of completed requests
    //
    private int completedRequests_;

    // -----------------------------------------------------------------
    // LoadCalculator_impl constructor
    // -----------------------------------------------------------------

    public LoadCalculator_impl()
    {
	activeRequests_ = 0;
	completedRequests_ = 0;
    }

    // -----------------------------------------------------------------
    // LoadCalculator_impl public member implementation
    // -----------------------------------------------------------------

    //
    // A new request was made.
    //
    public synchronized void
    newRequest()
    {
	activeRequests_++;
    }

    //
    // A request was completed.
    //
    public synchronized void
    requestCompleted()
    {
	activeRequests_--;
	com.ooc.OB.Assert._OB_assert(activeRequests_ >= 0);

	completedRequests_++;
    }

    // -----------------------------------------------------------------
    // IDL to Java Mapping
    // -----------------------------------------------------------------

    //
    // IDL:ooc.com/LoadBalancing/Util/LoadCalculator/calculate_load:1.0
    //
    public synchronized int
    calculate_load()
    {
	int load = activeRequests_ + completedRequests_;
	completedRequests_ = 0;

	return load;
    }
}
