// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

public class ConFactoryInfo_impl extends org.omg.CORBA.LocalObject
                                 implements ConFactoryInfo
{
    //
    // The protocol id
    //
    private String id_;

    //
    // The profile tag
    //
    private int tag_;

    //
    // The local peer id
    //
    private String localPeer_;

    //
    // ConFactory information delegate
    //
    private com.ooc.OCI.ConFactoryInfo delegate_;

    //
    // All connect callback objects
    //
    private java.util.Vector connectCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return id_;
    }

    public int
    tag()
    {
        return tag_;
    }

    public String
    describe()
    {
        String result = id_ + " connector factory" +
                        "\nlocal peer: " + localPeer_ +
                        '\n' + delegate_.describe();
        return result;
    }

    public synchronized void
    add_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
                return; // Already registered
        connectCBVec_.addElement(cb);
    }

    public synchronized void
    remove_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
            {
                connectCBVec_.removeElementAt(i);
                return;
            }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    ConFactoryInfo_impl(String id, int tag, String localPeer,
                        com.ooc.OCI.ConFactoryInfo delegate)
    {
        id_ = id;
        tag_ = tag;
        localPeer_ = localPeer;
        delegate_ = delegate;
    }

    synchronized com.ooc.OCI.ConnectCB[]
    _OB_getConnectCBSeq()
    {
        int length = connectCBVec_.size();
        com.ooc.OCI.ConnectCB[] cbs = new com.ooc.OCI.ConnectCB[length];
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.ConnectCB cb =
                (com.ooc.OCI.ConnectCB)connectCBVec_.elementAt(i);
            cbs[i] = cb;
        }
        return cbs;
    }
}
