// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

public class ConnectorInfo_impl extends org.omg.CORBA.LocalObject
    implements ConnectorInfo
{
    //
    // The protocol id
    //
    private String id_;

    //
    // The profile tag
    //
    private int tag_;

    //
    // The local peer id
    //
    private String localPeer_;

    //
    // The remote peer id
    //
    private String remotePeer_;

    //
    // The ConnectorInfo delegate
    //
    private com.ooc.OCI.ConnectorInfo delegate_;

    //
    // All connect callback objects
    //
    private java.util.Vector connectCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return id_;
    }

    public int
    tag()
    {
        return tag_;
    }

    public String
    describe()
    {
        String result;
        if(delegate_ == null)
        {
            result = id_ + " callback connector" +
                     "\nlocal peer: " + localPeer_ +
                     "\nremote peer: " + remotePeer_;
        }
        else
        {
            result = id_ + " connector" +
                     "\nlocal peer: " + localPeer_ +
                     "\nremote peer: " + remotePeer_ +
                     '\n' + delegate_.describe();
        }
        return result;
    }

    public synchronized void
    add_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
                return; // Already registered
        connectCBVec_.addElement(cb);
    }

    public synchronized void
    remove_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
            {
                connectCBVec_.removeElementAt(i);
                return;
            }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    ConnectorInfo_impl(String id, int tag,
                       String localPeer, String remotePeer,
                       com.ooc.OCI.ConnectCB[] callbacks,
                       com.ooc.OCI.ConnectorInfo delegate)
    {
        id_ = id;
        tag_ = tag;
        localPeer_ = localPeer;
        remotePeer_ = remotePeer;
        delegate_ = delegate;

        for(int i = 0 ; i < callbacks.length ; i++)
            connectCBVec_.addElement(callbacks[i]);
    }

    synchronized void
    _OB_callConnectCB(com.ooc.OCI.TransportInfo info)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.ConnectCB cb =
                (com.ooc.OCI.ConnectCB)connectCBVec_.elementAt(i);
            cb.connect_cb(info);
        }
    }
}
