// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

//
// Transport_impl represents the "forward" virtual connection
//
public class Transport_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Transport
{
    //
    // The protocol id
    //
    private String id_;

    //
    // The profile tag
    //
    private int tag_;

    //
    // The active transport
    //
    private ActiveTransport transport_;

    //
    // Transport information
    //
    private TransportInfo_impl info_;

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return id_;
    }

    public int
    tag()
    {
        return tag_;
    }

    public com.ooc.OCI.SendReceiveMode
    mode()
    {
        return com.ooc.OCI.SendReceiveMode.SendReceive;
    }

    public int
    handle()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    public void
    close()
    {
        //
        // Call callbacks
        //
        info_._OB_callCloseCB(info_);

        transport_.close(false);
    }

    public void
    shutdown()
    {
        transport_.shutdown(false);
    }

    public void
    receive(com.ooc.OCI.Buffer buf, boolean block)
    {
        transport_.receive(buf, block, false, null);
    }

    public boolean
    receive_detect(com.ooc.OCI.Buffer buf, boolean block)
    {
        return transport_.receiveDetect(buf, block, false, null);
    }

    public void
    receive_timeout(com.ooc.OCI.Buffer buf, int timeout)
    {
        transport_.receiveTimeout(buf, timeout, false, null);
    }

    public boolean
    receive_timeout_detect(com.ooc.OCI.Buffer buf, int timeout)
    {
        return transport_.receiveTimeoutDetect(buf, timeout, false, null);
    }

    public void
    send(com.ooc.OCI.Buffer buf, boolean block)
    {
        transport_.send(buf, block, false);
    }

    public boolean
    send_detect(com.ooc.OCI.Buffer buf, boolean block)
    {
        return transport_.sendDetect(buf, block, false);
    }

    public void
    send_timeout(com.ooc.OCI.Buffer buf, int timeout)
    {
        transport_.sendTimeout(buf, timeout, false);
    }

    public boolean
    send_timeout_detect(com.ooc.OCI.Buffer buf, int timeout)
    {
        return transport_.sendTimeoutDetect(buf, timeout, false);
    }

    public com.ooc.OCI.TransportInfo
    get_info()
    {
        return info_;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    Transport_impl(String id, int tag, ActiveTransport t,
                   com.ooc.OCI.Connector connector)
    {
        id_ = id;
        tag_ = tag;
        transport_ = t;
        info_ = new TransportInfo_impl(id_, tag_, t.localPeer(),
                                       t.remotePeer(), connector, t.info());
    }

    Transport_impl(String id, int tag, ActiveTransport t,
                   com.ooc.OCI.Acceptor acceptor)
    {
        id_ = id;
        tag_ = tag;
        transport_ = t;
        info_ = new TransportInfo_impl(id_, tag_, t.localPeer(),
                                       t.remotePeer(), acceptor, t.info());
    }
}
