// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CORBA;

final public class ORBPolicyFactory_impl extends org.omg.CORBA.LocalObject
    implements org.omg.PortableInterceptor.PolicyFactory
{
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public org.omg.CORBA.Policy
    create_policy(int type, org.omg.CORBA.Any any)
        throws org.omg.CORBA.PolicyError
    {
        try
        {
	    switch(type)
	    {
	    case com.ooc.OB.CONNECTION_REUSE_POLICY_ID.value:
	    {
		boolean b = any.extract_boolean();
		return new com.ooc.OB.ConnectionReusePolicy_impl(b);
	    }

	    case com.ooc.OB.PROTOCOL_POLICY_ID.value:
            {
                String[] seq = com.ooc.OCI.PluginIdSeqHelper.extract(any);
                return new com.ooc.OB.ProtocolPolicy_impl(seq);
            }

	    case com.ooc.OB.RETRY_POLICY_ID.value:
            {
	        try
		{
                    short v = any.extract_short();
                    if(v > com.ooc.OB.RETRY_ALWAYS.value)
                        throw new org.omg.CORBA.PolicyError(
			    org.omg.CORBA.BAD_POLICY_VALUE.value);
		    return new com.ooc.OB.RetryPolicy_impl(v, 0, 1, false);
		}
		catch(org.omg.CORBA.BAD_OPERATION ex)
		{
		}
		com.ooc.OB.RetryAttributes attr = 
		    com.ooc.OB.RetryAttributesHelper.extract(any);
                return new com.ooc.OB.RetryPolicy_impl(attr.mode, 
						       attr.interval,
						       attr.max,
						       attr.remote);
            }

	    case com.ooc.OB.TIMEOUT_POLICY_ID.value:
            {
                int t = any.extract_ulong();
                return new com.ooc.OB.TimeoutPolicy_impl(t);
            }

            case com.ooc.OB.LOCATION_TRANSPARENCY_POLICY_ID.value:
            {
                short v = any.extract_short();
                return new com.ooc.OB.LocationTransparencyPolicy_impl(v);
            }

	    case org.omg.Messaging.REQUEST_START_TIME_POLICY_TYPE.value:
	    {
	        org.omg.TimeBase.UtcT v = 
		    org.omg.TimeBase.UtcTHelper.extract(any);
		return new com.ooc.Messaging.RequestStartTimePolicy_impl(v);
	    }

	    case org.omg.Messaging.REQUEST_END_TIME_POLICY_TYPE.value:
	    {
	        org.omg.TimeBase.UtcT v = 
		    org.omg.TimeBase.UtcTHelper.extract(any);
		return new com.ooc.Messaging.RequestEndTimePolicy_impl(v);
	    }

	    case org.omg.Messaging.REPLY_START_TIME_POLICY_TYPE.value:
	    {
	        org.omg.TimeBase.UtcT v = 
		    org.omg.TimeBase.UtcTHelper.extract(any);
		return new com.ooc.Messaging.ReplyStartTimePolicy_impl(v);
	    }

	    case org.omg.Messaging.REPLY_END_TIME_POLICY_TYPE.value:
	    {
	        org.omg.TimeBase.UtcT v = 
		    org.omg.TimeBase.UtcTHelper.extract(any);
		return new com.ooc.Messaging.ReplyEndTimePolicy_impl(v);
	    }

	    case org.omg.Messaging.RELATIVE_REQ_TIMEOUT_POLICY_TYPE.value:
	    {
	        long v = any.extract_long();
		return new
		    com.ooc.Messaging.RelativeRequestTimeoutPolicy_impl(v);
	    }

	    case org.omg.Messaging.RELATIVE_RT_TIMEOUT_POLICY_TYPE.value:
	    {
	        long v = any.extract_long();
		return new
		    com.ooc.Messaging.RelativeRoundTripTimeoutPolicy_impl(v);
	    }

            case org.omg.Messaging.REBIND_POLICY_TYPE.value:
            {
                short v = any.extract_short();
                return new com.ooc.Messaging.RebindPolicy_impl(v);
            }

            case org.omg.Messaging.SYNC_SCOPE_POLICY_TYPE.value:
            {
                short v = any.extract_short();
                return new com.ooc.Messaging.SyncScopePolicy_impl(v);
            }

            case com.ooc.OB.INTERCEPTOR_POLICY_ID.value:
            {
                boolean v = any.extract_boolean();
                return new com.ooc.OB.InterceptorPolicy_impl(v);
            }

	    case com.ooc.OB.CONNECT_TIMEOUT_POLICY_ID.value:
            {
                int t = any.extract_ulong();
                return new com.ooc.OB.ConnectTimeoutPolicy_impl(t);
            }

	    case com.ooc.OB.REQUEST_TIMEOUT_POLICY_ID.value:
            {
                int t = any.extract_ulong();
                return new com.ooc.OB.RequestTimeoutPolicy_impl(t);
            }

	    case com.ooc.OB.LOCATE_REQUEST_POLICY_ID.value:
            {
                boolean b = any.extract_boolean();
                return new com.ooc.OB.LocateRequestPolicy_impl(b);
            }
	    }
        }
        catch(org.omg.CORBA.BAD_OPERATION ex)
        {
            //
            // Any extraction failure
            //
            throw new org.omg.CORBA.PolicyError(
		org.omg.CORBA.BAD_POLICY_TYPE.value);
        }

        throw new org.omg.CORBA.PolicyError(
	    org.omg.CORBA.BAD_POLICY.value);
    }
}
