// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.IIOP;

final class ConnectorInfo_impl extends org.omg.CORBA.LocalObject
    implements ConnectorInfo
{
    private Connector_impl connector_; // The associated connector

    //
    // All connect callback objects
    //
    private java.util.Vector connectCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return PLUGIN_ID.value;
    }

    public int
    tag()
    {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public synchronized String
    describe()
    {
        String desc = "id: " + PLUGIN_ID.value;

        byte[] remoteAddr = remote_addr();
        short remotePort = remote_port();
        desc += "\nremote address: ";
        desc += (remoteAddr[0] < 0 ? 0xff + (int)remoteAddr[0] + 1
                                   : remoteAddr[0]);
        desc += ".";
        desc += (remoteAddr[1] < 0 ? 0xff + (int)remoteAddr[1] + 1
                                   : remoteAddr[1]);
        desc += ".";
        desc += (remoteAddr[2] < 0 ? 0xff + (int)remoteAddr[2] + 1
                                   : remoteAddr[2]);
        desc += ".";
        desc += (remoteAddr[3] < 0 ? 0xff + (int)remoteAddr[3] + 1
                                   : remoteAddr[3]);
        desc += ":";
        desc += (remotePort < 0 ? 0xffff + (int)remotePort + 1 : remotePort);

        return desc;
    }

    public synchronized void
    add_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
                return; // Already registered
        connectCBVec_.addElement(cb);
    }

    public synchronized void
    remove_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(connectCBVec_.elementAt(i) == cb)
            {
                connectCBVec_.removeElementAt(i);
                return;
            }
    }

    public synchronized byte[]
    remote_addr()
    {
	if(connector_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES("No connector");

        try
        {
            java.net.InetAddress address =
                java.net.InetAddress.getByName(connector_.host_);
            return address.getAddress();
        }
        catch(java.net.UnknownHostException ex)
        {
            throw new org.omg.CORBA.COMM_FAILURE(
                com.ooc.OB.MinorCodes.describeCommFailure(
                    com.ooc.OB.MinorCodes.MinorGethostbyname) +
                    ": " + ex.toString(),
                com.ooc.OB.MinorCodes.MinorGethostbyname,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }
    }

    public synchronized short
    remote_port()
    {
	if(connector_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES("No connector");

        int port = connector_.port_;

	if(port >= 0x8000)
	    return (short)(port - 0xffff - 1);
	else
	    return (short)port;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    ConnectorInfo_impl(Connector_impl connector, com.ooc.OCI.ConnectCB[] cb)
    {
        connector_ = connector;

        for(int i = 0 ; i < cb.length ; i++)
            connectCBVec_.addElement(cb[i]);
    }

    synchronized void
    _OB_callConnectCB(com.ooc.OCI.TransportInfo info)
    {
        int length = connectCBVec_.size();
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.ConnectCB cb =
                (com.ooc.OCI.ConnectCB)connectCBVec_.elementAt(i);
            cb.connect_cb(info);
        }
    }

    synchronized void
    _OB_destroy()
    {
	connector_ = null;
    }
}
